SystemOrganization addCategory: 'tODE-Metacello'!

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 04:06'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewPackageClasses;
		renderer:
				((TOPackageSidebar new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'package classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 11:11'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: ((TOPackage new)
			mbPackageInfo: self;
			yourself);  
		sidebarSpec: self tODEViewSidebarSpec;
		yourself! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 09:52'!
todeCssClass
	|  wc loadedPkgName cssSpanClass |
	(wc := self workingCopy) isNil
		ifTrue: [ ^ super todeCssClass ].
	cssSpanClass := ''.
	wc ancestry ancestors notEmpty
		ifTrue: [ 
			loadedPkgName := wc ancestry ancestors first name.
			loadedPkgName = self name
				ifFalse: [ 
					(self compareWorkingCopyNamed: loadedPkgName using: #<=)
						ifTrue: [ cssSpanClass := 'outofspec ' ].
					cssSpanClass := cssSpanClass , 'mismatch ' ] ].
	self isDirty
		ifTrue: [ cssSpanClass := cssSpanClass , 'dirty ' ].
	^cssSpanClass! !

!MCPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 12:28'!
renderViewSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer mcPatch: self.
	aTOTabSpec renderer renderContentOn: html main: main! !

!MCPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 12:29'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewPackageClasses;
		rendererClass: TOPatchList;
		receiver: self;
		label: 'changes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderViewSidebarOn:spec:tOdeMain:)}! !

!MCPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 11:25'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #view;
		rendererClass: TOPatch;  
		receiver: self;
		label: 'view';
		order: 5;
		group: 'basic';
		sidebarSpec: self tODEViewSidebarSpec;
		renderSelector: #renderViewContentOn:spec:main:! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 7/8/2011 08:10'!
renderFrameTitleOn: html main: main
	| cl |
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	(html span)
		class: 'naviode';
		with: [ 
					self renderStyledLabelOn: html main: main.
					html space.
					html small: '(' , cl name , ')' ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 7/7/2011 16:31'!
renderLabelOn: html main: main
	(html span)
		class: 'naviode';
		with: [ self renderStyledLabelOn: html main: main ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 10:00'!
renderStyledLabelOn: html main: main
	(html span)
		class: self todeCssClass;
		with: [ html text: self printString ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 09:52'!
todeCssClass
	^ 'default'! !

!MetacelloMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/27/2011 14:40'!
isAdd
	^ false! !

!MetacelloMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/27/2011 14:40'!
isCopy
	^ false! !

!MetacelloMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/27/2011 14:40'!
isMerge
	^ false! !

!MetacelloMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/27/2011 14:40'!
isRemove
	^ false! !

!MBVersionInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 05:47'!
tODEViewTabSpec
	<tODECenterTabSpec>
	^ (super tODEViewTabSpec)
		renderer:
				((TOVersion new)
						object: self;
						mbVersionInfo: self;
						yourself);
		sidebarSpec: self tODEVersionSidebarSpec;
		yourself! !

!MetacelloRemoveMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/28/2011 20:32'!
isRemove
	^ true! !

!MBBaselineInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 05:48'!
tODEViewTabSpec
	<tODECenterTabSpec>
	^ (super tODEViewTabSpec)
		renderer:
				((TOBaselineVersion new)
						object: self;
						mbVersionInfo: self;
						yourself);
		sidebarSpec: self tODEVersionSidebarSpec;
		yourself! !

!TOSystem methodsFor: '*tode-metacello' stamp: 'dkh 6/3/2011 16:06'!
configurationRoot

	^MBConfigurationRoot current! !

TOSidebar subclass: #TOPackageSidebar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOPackageSidebar subclass: #TOConfigurationSidebar
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:22'!
configurationInfo

	^(self frame rendererForCenterTab: self specLabel) mbConfigurationInfo! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 08/04/2011 16:32'!
currentVersion
	self configurationInfo ifNil: [ ^ nil ].
	^ self configurationInfo currentVersion! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:47'!
defaultSpecLabel
	^ #configuration! !

!TOConfigurationSidebar methodsFor: 'rendering' stamp: 'dkh 6/13/2011 21:43'!
renderContentOn: html main: main
	| id |
	(html select)
		id: (id := html nextId);
		list: self selectionList;
		selected: self selection;
		callback: [ :index | self selectIndex: index ];
		onChange:
				((html jQuery ajax)
						callback: [ :index | self selectIndex: index ] value: (html jQuery id: id) value;
						script: [ :s | main updateSidebarOn: s ]).
	html break.
	self selection = 'classes'
		ifTrue: [ ^ self renderClassListOn: html main: main ].
	self selection = 'currentVersion'
		ifTrue: [ ^ self renderCurrentVersionOn: html main: main ].
	self selection = 'versions'
		ifTrue: [ ^ self renderVersionListOn: html main: main ]! !

!TOConfigurationSidebar methodsFor: 'rendering' stamp: 'dkh 7/7/2011 16:38'!
renderCurrentVersionOn: html main: main
	| cvs list cv cvInfo |
	self configurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			^ self ].
	cvs := ''.
	(cv := self configurationInfo currentVersion) ~~ nil
		ifTrue: [ cvs := cv versionString ].
	(html heading)
		level: 3;
		with: self configurationInfo printString.
	cvInfo := self configurationInfo infoFor: cvs.
	(html span)
		class: 'naviode';
		with: [ 
					(list := self configurationInfo projects) notEmpty
						ifTrue: [ 
							html text: ' -- '.
							self
								renderLink: [ :s | 
									self currentSession push: cvInfo selecting: #view.
									main updateCenterSideHistory: s ]
								with: [ html text: cvs ]
								on: html.
							html
								text: ' projects --';
								break;
								break.
							list
								do: [ :info | 
									| projectConfig |
									(projectConfig := info projectConfiguration) notNil
										ifTrue: [ 
											self
												renderLink: [ :s | 
													self currentSession push: projectConfig selecting: #view.
													main updateCenterSideHistory: s ]
												with: [ info renderLabelOn: html main: main ]
												on: html ]
										ifFalse: [ info renderLabelOn: html main: main ].
									html break ].
							html break ].
					(list := self configurationInfo packages) notEmpty
						ifTrue: [ 
							html text: ' -- '.
							self
								renderLink: [ :s | 
									self currentSession push: cvInfo selecting: #view.
									main updateCenterSideHistory: s ]
								with: [ html text: cvs ]
								on: html.
							html
								text: ' packages --';
								break;
								break.
							list
								do: [ :info | 
									info workingCopy
										ifNil: [ info renderLabelOn: html main: main ]
										ifNotNil: [ 
											self
												renderLink: [ :s | 
													self currentSession push: info selecting: #view.
													main updateCenterSideHistory: s ]
												with: [ info renderLabelOn: html main: main ]
												on: html ].
									html break ].
							html break ].
					(list := self configurationInfo groups) notEmpty
						ifTrue: [ 
							html text: ' -- '.
							self
								renderLink: [ :s | 
									self currentSession push: cvInfo selecting: #view.
									main updateCenterSideHistory: s ]
								with: [ html text: cvs ]
								on: html.
							html
								text: ' groups --';
								break;
								break.
							list
								do: [ :info | 
									info renderLabelOn: html main: main.
									html break ] ] ]! !

!TOConfigurationSidebar methodsFor: 'rendering' stamp: 'dkh 7/7/2011 16:50'!
renderVersionListOn: html main: main
	self configurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			^ self ].
	(html heading)
		level: 3;
		with: self configurationInfo printString.
	(html div)
		class: 'naviode';
		with: [ 
					self configurationInfo project
						ifNil: [ 
							^ (html span)
								class: 'error';
								with: 'no project defined' ].
					html
						text: ' -- baselines --';
						break.
					(self configurationInfo trimVersionInfos: self configurationInfo baselines)
						do: [ :info | 
							(info isKindOf: MBAbstractVersionInfo)
								ifTrue: [ 
									self
										renderLink: [ :s | 
											self currentSession push: info selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ info renderLabelOn: html main: main ]
										on: html ]
								ifFalse: [ info renderLabelOn: html main: main ].
							html break ].
					html
						break;
						text: ' -- versions --';
						break.
					(self configurationInfo trimVersionInfos: self configurationInfo versions)
						do: [ :info | 
							(info isKindOf: MBAbstractVersionInfo)
								ifTrue: [ 
									self
										renderLink: [ :s | 
											self currentSession push: info selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ info renderLabelOn: html main: main ]
										on: html ]
								ifFalse: [ info renderLabelOn: html main: main ].
							html break ] ]! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:26'!
selectIndex: index

	selection := self selectionList at: index asInteger! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 7/5/2011 09:35'!
selection
	selection ifNil: [ selection := self currentVersion ifNil: [ 'versions' ] ifNotNil: [ 'currentVersion' ] ].
	^ selection! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:56'!
selection: anObject
	selection := anObject! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:58'!
selectionList

	^{'classes'. 'currentVersion'. 'versions'. }.
! !

!TOPackageSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 04:17'!
defaultSpecLabel
	^ #package! !

!TOPackageSidebar methodsFor: 'rendering' stamp: 'DataCurator 07/12/2011 15:25'!
renderClassListOn: html main: main
	| order classes indents displayString classList extensionClassList |
	order := SortedCollection
		sortBlock: [ :assoc1 :assoc2 | 
			| result chain1 chain2 max i |
			result := nil.
			chain1 := assoc1 key.
			chain2 := assoc2 key.
			max := chain1 size min: chain2 size.
			i := 1.
			[ result isNil and: [ i <= max ] ]
				whileTrue: [ 
					(chain1 at: i) = (chain2 at: i)
						ifTrue: [ i := i + 1 ]
						ifFalse: [ result := (chain1 at: i) name < (chain2 at: i) name ] ].
			result isNil
				ifTrue: [ chain1 size < chain2 size ]
				ifFalse: [ result ] ].
	classList := (self frame rendererForCenterTab: self specLabel) classList.
	extensionClassList := (self frame rendererForCenterTab: self specLabel) extensionClassList.
	classList
		do: [ :cl | extensionClassList removeKey: cl ifAbsent: []].
	classes :=  classList, extensionClassList keys asArray.
	classes
		do: [ :cl | 
			| supersChain |
			supersChain := cl withAllSuperclasses reversed.
			supersChain removeAllSuchThat: [ :class | (classes includes: class) not ].
			order add: supersChain contents -> cl ].
	indents := IdentityDictionary new.
	order do: [ :assoc | indents at: assoc value put: assoc key size - 1 ].
	classes := classes asArray sorted: [ :a :b | a name <= b name ].
	order
		do: [ :assoc | 
			| cl |
			cl := assoc value.
			(indents at: cl) * 2 timesRepeat: [ html space ].
			self
				renderLink: [ :s | | fr |
					fr := self currentSession push: cl selecting: ((extensionClassList includesKey: cl)
								ifTrue: [#methodSourceBrowser]
								ifFalse: [#classBrowser]).
					(extensionClassList includesKey: cl)
						ifTrue: [| browser selector |
							browser := fr rendererForCenterTab: #methodSourceBrowser.
							selector := (cl organization listAtCategoryNamed: (extensionClassList at: cl) first) first.
							browser methodReference: (self currentSystem methodReferenceClass class: cl selector: selector) ].
					main updateCenterSideHistory: s ]
				with: [ 
					(extensionClassList includesKey: cl)
								ifTrue: [html text: cl name asString]
								ifFalse: [html strong: cl name asString].
					html break ]
				on: html ]! !

!TOPackageSidebar methodsFor: 'rendering' stamp: 'dkh 6/13/2011 20:49'!
renderContentOn: html main: main
	self renderClassListOn: html main: main! !

TOSidebar subclass: #TOVersionSidebar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOVersionSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 04:17'!
defaultSpecLabel
	^ #version! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:45'!
indent: count on: html
	self toVersion indent: count on: html! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:46'!
indentIncrement
	^ self toVersion indentIncrement! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:46'!
label: labelBlock on: html
	self toVersion label: labelBlock value: nil on: html
! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:46'!
label: labelBlock value: valueBlock on: html
	self toVersion label: labelBlock value: valueBlock on: html! !

!TOVersionSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:17'!
mbConfigurationInfo

	^self toVersion mbConfigurationInfo! !

!TOVersionSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:17'!
mbVersionInfo

	^self toVersion mbVersionInfo! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/25/2011 05:18'!
renderContentOn: html main: main
	self renderViewContentOn: html main: main! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 07/20/2011 15:38'!
renderFrameTitleOn: html main: main
	| cl |
	self mbConfigurationInfo ifNil: [ ^ super renderFrameTitleOn: html main: main ].
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	html strong: (MetacelloToolBox baseNameOf: self mbConfigurationInfo name).
	html space.
	html text: 'version'.
	html space.
	html strong: self mbVersionInfo versionString.
	html space.
	html small: '(' , cl name , ')'! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 08/04/2011 16:33'!
renderViewContentOn: html main: main
	| vms indent selected |
	(vms := self versionMethodSpec) ifNil: [ ^ html text: 'No version defined' ].
	indent := 0.
	(html span)
		class: 'shout';
		with: [ 
					html strong: 'configuration: '.
					self
						renderLink: [ :s | 
							self currentSession push: self mbConfigurationInfo selecting: #view.
							main updateCenterSideHistory: s ]
						with: [ self mbConfigurationInfo renderStyledLabelOn: html main: main ]
						on: html.
					html
						break;
						break.
					self
						renderIntraPageLink: [ :s | 
							(self toVersion)
								aspect: nil;
								aspectPath: nil.
							main updateCenterSideHistory: s ]
						with: [ self label: [ html text: 'version' ] on: html ]
						on: html.
					html text: ': '.
					html strong: vms versionString.
					vms imports notEmpty
						ifTrue: [ 
							html space.
							self label: [ html text: 'imports: ' ] on: html.
							vms imports
								do: [ :import | 
									self
										renderLink: [ :s | 
											self currentSession push: (self mbVersionInfo configurationInfo infoFor: import) selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ html strong: import ]
										on: html.
									html space ] ].
					html break.
					selected := nil.
					self toVersion aspectPath notEmpty
						ifTrue: [ selected := self toVersion aspectPath at: 1 ].
					vms methodSections
						do: [ :section | 
							| path |
							self toVersion
								backgroundColor: section = selected
								on: html
								do: [ 
									self indent: indent on: html.
									self
										renderIntraPageLink: [ :s | 
											(self toVersion)
												aspect: #section;
												aspectPath: {section}.
											main updateCenterSideHistory: s ]
										with: [ 
											(html span)
												class: 'symbol';
												with: [ html text: section attribute printString ] ]
										on: html ].
							html break.
							self toVersion
								renderVersionSpec: section versionSpec
								path: {section}
								indent: indent + self indentIncrement
								on: html
								main: main.
							self toVersion
								renderPackagesSpecs: section versionSpec
								path: {section}
								indent: indent + self indentIncrement
								on: html
								main: main ] ]! !

!TOVersionSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:16'!
toVersion

	^self frame rendererForCenterTab: self specLabel! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:46'!
value: valueBlock on: html
	self toVersion label: nil value: valueBlock on: html
! !

!TOVersionSidebar methodsFor: 'accessing' stamp: 'dkh 08/04/2011 16:20'!
versionMethodSpec
	^ self toVersion versionMethodSpec! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/23/2011 17:22'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewConfigurationClasses;
		renderer:
				((TOConfigurationSidebar new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'configuration view classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 11:24'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: ((TOConfiguration new)
			mbConfigurationInfo: self;
			yourself);  
		sidebarSpec: self tODEViewSidebarSpec;
		yourself! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 09:59'!
todeCssClass
	| cv specVersion wc cssSpanClass |
	[ 
	cssSpanClass := ''.
	((wc := self workingCopy) notNil and: [ wc needsSaving ])
		ifTrue: [ cssSpanClass := 'dirty ' ].
	self isDirty
		ifTrue: [ cssSpanClass := 'contentsdirty ' , cssSpanClass ].
	self currentVersion.	"prime the pump"
	currentVersion == #notLoaded
		ifTrue: [ ^ cssSpanClass ].
	super isDirty | self currentVersionMismatch
		ifTrue: [ cssSpanClass := 'mismatch ' , cssSpanClass ].
	self currentVersion versionStatus == #somethingLoaded
		ifTrue: [ cssSpanClass := cssSpanClass , 'somethingloaded ' ].
	^ cssSpanClass ] on: Error do: [ :ex | ^ 'error' ]! !

!MetacelloCopyMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/28/2011 20:29'!
isCopy
	^ true! !

!MCWorkingCopy methodsFor: '*tode-metacello' stamp: 'dkh 6/15/2011 16:08'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #view;
		renderer: ((TOWorkingCopy new)
			workingCopy: self;
			yourself);  
		receiver: self;
		label: 'view';
		order: 5;
		group: 'basic';
		renderSelector: #renderViewContentOn:spec:main:! !

!MetacelloSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 09:52'!
renderViewContentOn: html main: main
	html preformatted: self printString
! !

!MBAbstractVersionInfo methodsFor: '*tode-metacello' stamp: 'dkh 07/20/2011 15:35'!
renderFrameTitleOn: html main: main
	| cl |
	self configurationInfo ifNil: [ ^ super renderFrameTitleOn: html main: main ].
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	html strong: (MetacelloToolBox baseNameOf: self configurationInfo name).
	html space.
	html text: 'version'.
	html space.
	html strong: self versionString.
	html space.
	html small: '(' , cl name , ')'! !

!MBAbstractVersionInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 05:44'!
tODEVersionSidebarSpec
	^ {((TOTabSpec new)
		id: #versionSpec;
		renderer:
				((TOVersionSidebar new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'version spec';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!MetacelloVersionMethodSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 15:33'!
renderViewContentOn: html main: main
	html text: 'verrsion: '.
	html text: self versionString printString.
	html space.
	html text: 'imports: #('.
	self imports
		do: [ :import | 
			html text: import printString.
			html space ].
	html text: ')'.
	html break.
	self methodSections
		do: [ :section | 
			section renderViewContentOn: html main: main.
			html break ]! !

!TextDiffBuilder methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 14:36'!
renderContentOn: html view: aTOPatch main: main
	| lineEndings |
	lineEndings := String cr , String lf.
	(html div)
		class: 'naviode';
		with: [ 
					html
						preformatted: [ 
							self
								patchSequenceDoIfMatch: [ :string | html text: string; break ]
								ifInsert: [ :string | 
									(html span)
										class: 'insert';
										with: [ html text: string; break ] ]
								ifRemove: [ :string | 
									(html span)
										class: 'remove';
										with: [ html text: string; break ] ] ] ]! !

!MCPatchOperation methodsFor: '*tode-metacello' stamp: 'dkh 07/12/2011 10:18'!
renderContentOn: html view: aTOPatch main: main
	self renderNavigationOn: html view: aTOPatch main: main.
	^ (TextDiffBuilder from: self fromSource to: self toSource) renderContentOn: html view: aTOPatch main: main! !

!MCPatchOperation methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 19:03'!
renderNavigationOn: html view: aTOPatch main: main

	| class |
	(class := self targetClass) ifNil: [ ^html strong: self targetClass name asString ].
	aTOPatch
		renderLink: [ :s | 
			main currentSession push: class selecting: #methodClassBrowser.
			main updateCenterSideHistory: s ]
		with: [html strong: class name asString]
		on: html.
	self isClassPatch ifTrue: [ ^self ].
	html text: '>>'.
	aTOPatch
		renderLink: [ :s | | fr selector |
			fr := main currentSession push: class selecting: #methodSourceBrowser.
selector := self definition selector.
(class includesSelector: selector)
  ifTrue: [ 
			(fr rendererForCenterTab: #methodSourceBrowser) methodReference: (MethodReference class: class selector: selector) ].
			main updateCenterSideHistory: s ]
		with: [html strong: self definition selector]
		on: html.
! !

!MetacelloAddMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/28/2011 20:28'!
isAdd
	^ true! !

!MetacelloMergeMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/28/2011 20:29'!
isMerge
	^ true! !

!TOHome methodsFor: '*tode-metacello' stamp: 'dkh 8/2/2011 13:41'!
renderMetacelloHomeViewContentOn: html spec: aTOTabSpec main: main
	<tODEHomeView>
	| projectList |
	projectList := self properties
		at: #metacelloProjectList
		ifAbsent: [ self properties at: #metacelloProjectList put: (TOConfigurationList new frame: self frame) ].
	projectList resetSearch.
	html strong: 'Projects ('.
	self
		renderIntraPageLink: [ :s | 
			projectList showDetails: projectList showDetails not.
			main updateCenterSideHistory: s ]
		with: [ 
			projectList showDetails
				ifTrue: [ html text: 'names' ]
				ifFalse: [ html text: 'details' ] ]
		on: html.
	html strong: '):'.
	html
		unorderedList: [ 
			projectList renderViewContentOn: html main: main.
			html break.
			self
				renderButton: [ :s | 
					| us undefined dict |
					MBConfigurationRoot reset.
					main updateCenterSideHistory: s ]
				label: 'reset configuration root'
				on: html ]! !

!TOSearch methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 08:08'!
configurationQueryResults
	<todeSearch: 'Configurations' selector: #configurationSearch priority: 35>
	^ (MBConfigurationRoot current configurations select: [ :ci | ci name includesSubstring: searchText caseSensitive: false ]) sorted: [ :a :b | a name <= b name ]! !

!TOSearch methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 07:42'!
packageQueryResults
	<todeSearch: 'Packages' selector: #packageSearch priority: 30>
	^ (MCWorkingCopy allManagers select: [ :wc | wc packageName includesSubstring: searchText caseSensitive: false ])
		sorted: [ :a :b | a packageName <= b packageName ]! !

!MetacelloProjectSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/27/2011 15:53'!
getOperator

	^operator! !

TOView subclass: #TOMetacelloView
	instanceVariableNames: 'configurationSearchResults advancedSearch repositoryMap searchTerm selectedRepositoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOMetacelloView subclass: #TOAbstractVersion
	instanceVariableNames: 'mbVersionInfo versionMethodSpec aspect aspectPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 11:48'!
aspect
	aspect ifNil: [ aspect := #versionMethodSpec ].
	^ aspect! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 11:48'!
aspect: aSymbol
	aspect := aSymbol! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 16:35'!
aspectPath
	aspectPath ifNil: [ ^ #() ].
	^ aspectPath! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 16:32'!
aspectPath: aCollection
	aspectPath := aCollection! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/29/2011 10:26'!
backgroundColor: selected on: html do: aBlock
	| backgroundCssClass |
	backgroundCssClass := 'defaultBackground'.
	selected
		ifTrue: [ backgroundCssClass := 'selectedBackground' ].
	(html span)
		class: backgroundCssClass;
		with: aBlock! !

!TOAbstractVersion methodsFor: 'actions' stamp: 'dkh 7/6/2011 17:57'!
commit
	self versionMethodSpec compileMethod.
	self refresh! !

!TOAbstractVersion methodsFor: 'private' stamp: 'dkh 6/24/2011 16:02'!
constructor
	| constructor |
	constructor := MetacelloToolBoxConstructor new.
	constructor setProject: self project.
	constructor configuration: self project configuration class new.
	^ constructor! !

!TOAbstractVersion methodsFor: 'private' stamp: 'dkh 08/04/2011 16:24'!
createVersionMethodSpec
	| constructor version coll pragma imports sourceVersionString vms |
	self mbVersionInfo ifNil: [ ^ nil ].
	version := self mbVersionInfo version.
	sourceVersionString := version versionString.
	constructor := self constructor.
	coll := constructor extractAllVersionPragmas at: sourceVersionString ifAbsent: [ ^ nil ].
	coll size > 1
		ifTrue: [ self error: 'More than one pragma defining ' , sourceVersionString printString ].
	pragma := coll at: 1.
	imports := pragma numArgs = 2
		ifTrue: [ pragma argumentAt: 2 ]
		ifFalse: [ #() ].
	vms := (MetacelloVersionMethodSpec new)
		project: self project;
		selector: pragma selector;
		category: (self project configuration class whichCategoryIncludesSelector: pragma selector);
		versionString: sourceVersionString;
		imports: imports;
		yourself.
	constructor extractMethodSectionsFor: sourceVersionString.
	constructor methodSections do: [ :methodSection | vms methodSections add: methodSection ].
	^ vms! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 17:00'!
currentSection
	self aspectPath isEmpty
		ifTrue: [ ^ nil ].
	^ self aspectPath first! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:42'!
indent: count on: html
	count timesRepeat: [ html space ]! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:42'!
indentIncrement

^4! !

!TOAbstractVersion methodsFor: 'testing' stamp: 'dkh 7/7/2011 07:50'!
isBaselineVersion
	^ false! !

!TOAbstractVersion methodsFor: 'testing' stamp: 'dkh 7/7/2011 07:51'!
isVersion
	^ false! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:42'!
label: labelBlock on: html
	self label: labelBlock value: nil on: html
! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:42'!
label: labelBlock value: valueBlock on: html
	labelBlock
		ifNotNil: [ 
			(html span)
				class: 'keyword';
				with: labelBlock ].
	valueBlock
		ifNotNil: [ 
			(html span)
				class: 'string';
				with: valueBlock ]! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:09'!
mbConfigurationInfo
	mbVersionInfo
		ifNil: [ 
			| wc |
			MCWorkingCopy registry
				do: [ :mgr | 
					(mgr packageInfo includesClass: self actualClass)
						ifTrue: [ wc := mgr ] ].
			wc ifNil: [ ^ nil ].
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = wc packageName
								ifTrue: [ ^ config ] ] ].
			^ nil ].
	^ self mbVersionInfo configurationInfo! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/25/2011 04:30'!
mbVersionInfo
	mbVersionInfo
		ifNil: [ 
			| configurationInfo |
			(configurationInfo := self mbConfigurationInfo)
				ifNotNil: [ 
					| cv |
					(cv := configurationInfo currentVersion)
						ifNotNil: [ mbVersionInfo := configurationInfo infoFor: cv versionString ] ] ].
	^ mbVersionInfo! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/23/2011 16:48'!
mbVersionInfo: anMBVersionInfo
	mbVersionInfo := anMBVersionInfo! !

!TOAbstractVersion methodsFor: 'private' stamp: 'dkh 6/28/2011 20:34'!
memberTypeFor: memberSpec

	^ memberSpec isAdd
		ifTrue: [ 'add' ]
		ifFalse: [ 
			memberSpec isCopy
				ifTrue: [ 'copy' ]
				ifFalse: [ 
					memberSpec isMerge
						ifTrue: [ 'merge' ]
						ifFalse: [ 'remove' ] ] ]! !

!TOAbstractVersion methodsFor: 'private' stamp: 'dkh 6/24/2011 15:21'!
project
	^ self mbVersionInfo project! !

!TOAbstractVersion methodsFor: 'actions' stamp: 'dkh 7/6/2011 17:57'!
refresh
	mbVersionInfo := mbVersionInfo configurationInfo infoFor: mbVersionInfo versionString! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/5/2011 17:48'!
renderCommands: section on: html main: main
	html horizontalRule.
	self renderSearchCommandOn: html main: main.
	html break! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/25/2011 05:19'!
renderContentOn: html main: main
	self renderViewContentOn: html main: main! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/11/2011 19:38'!
renderDescriptionEditor: section on: html main: main
	| id spec fieldValue indent |
	indent := self renderSectionEditorHeading: section on: html main: main.
	self indent: indent on: html.
	spec := section versionSpec.
	fieldValue := spec description value.
	self label: [ html text: 'description: ' ] on: html.
	html break.
	(html textArea)
		id: (id := html nextId);
		columns: (self textAreaColumns: fieldValue);
		rows: (self textAreaRows: fieldValue);
		value: fieldValue;
		onChange: (html jQuery ajax callback: [ :value | fieldValue := value ] value: (html jQuery id: id) value).
	html break.
	(html submitButton)
		onClick:
				(html jQuery ajax
						script: [ :s | 
							spec description: fieldValue.
							self commit.
							self aspect: #section.
							main updateCenterSideHistory: s ]);
		with: 'Save'.
	html space.
	(html cancelButton)
		onClick:
				((html jQuery id: id)
						script: [ :s | 
							self aspect: #section.
							main updateCenterSideHistory: s ]);
		with: 'Cancel'! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 21:19'!
renderFieldEditor: fieldLabel get: getBlock set: setBlock indent: indent on: html main: main
	| id |
	self indent: indent on: html.
	(html textInput)
		id: (id := html nextId);
		value: getBlock value;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | setBlock value: value ] value: (html jQuery id: id) value;
						script: [ :s | main updateCenterSideHistory: s ]).
	self label: [ html text: fieldLabel ] on: html.
	html break! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/6/2011 12:22'!
renderGroupEditor: groupSpecMember on: html main: main
	| indent groupSpec memberType packageNames |
	indent := self renderSectionEditorHeading: self currentSection on: html main: main.
	groupSpec := groupSpecMember spec.
	memberType := self memberTypeFor: groupSpecMember.
	self indent: indent on: html.
	self label: [ html strong: 'groups:' ] on: html.
	html break.
	indent := indent + self indentIncrement.
	self indent: indent on: html.
	self value: [ html strong: groupSpec name ] on: html.
	html small: ' (' , memberType , '): '.
	html break.
	memberType = 'remove'
		ifTrue: [ ^ self ].
	packageNames := (self project attributes includes: self currentSection attribute)
		ifTrue: [ self version projects , self version packages , self version groups collect: [ :each | each name ] ]
		ifFalse: [ #() ].
	self
		renderListEditor: groupSpec includes copy
		label: 'members:'
		buttonLabel: 'add group member'
		exampleText:
			(packageNames isEmpty
				ifTrue: [ 'package/project/group name' ]
				ifFalse: [ 
					| coll |
					coll := packageNames copy.
					coll removeAllFoundIn: groupSpec includes.
					coll remove: groupSpec name ifAbsent: [].
					coll ])
		set: [ :includes | 
			groupSpec includes: includes.
			self commit ]
		indent: indent
		on: html
		main: main! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/28/2011 20:16'!
renderGroupSpec: groupSpecMember path: path indent: indent on: html main: main
	| blocks groupSpec memberType |
	blocks := OrderedCollection new.
	groupSpec := groupSpecMember spec.
	memberType := self memberTypeFor: groupSpecMember.
	groupSpec includes notEmpty
		ifTrue: [ 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: 'includes: ' on: html.
					groupSpec includes
						do: [ :str | 
							self value: str printString on: html.
							html space ].
					html break ] ].
	self indent: indent on: html.
	self
		renderLink: [ :s | 
			self
				aspect: #group;
				aspectPath: path , {groupSpecMember}.
			main updateCenterSideHistory: s ]
		with: [ self value: [ html strong: groupSpec name ] on: html ]
		on: html.
	html small: ' (' , memberType , '): '.
	blocks isEmpty
		ifTrue: [ ^ html break ].
	blocks size > 1
		ifTrue: [ html break ].
	blocks do: [ :block | block value: blocks size > 1 value: indent + self indentIncrement ]! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/29/2011 15:52'!
renderList: nameList label: label indent: indent on: html main: main
	nameList ifNil: [ ^ self ].
	self indent: indent on: html.
	self label: [ html text: label ] on: html.
	html break.
	nameList
		do: [ :name | 
			self indent: indent + self indentIncrement on: html.
			html text: name.
			html break ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/7/2011 15:57'!
renderListEditor: nameList label: label buttonLabel: buttonLabel exampleText: exampleText set: setBlock indent: indent on: html main: main
	| maxLength did list |
	self indent: indent on: html.
	self label: [ html strong: label ] on: html.
	html break.
	maxLength := exampleText isString
		ifTrue: [ exampleText size ]
		ifFalse: [ 0 ].
	(list := nameList) ifNil: [ list := #() ].
	list do: [ :mame | maxLength := maxLength max: mame size ].
	1 to: list size do: [ :index | 
		self indent: indent + self indentIncrement on: html.
		(html textInput)
			id: (did := html nextId);
			value: (list at: index);
			size: maxLength;
			onEnter:
					((html jQuery ajax)
							callback: [ :value | 
										list at: index put: value.
										value isEmpty
											ifTrue: [ list := list copyWithoutIndex: index ].
										setBlock value: list ]
								value: (html jQuery id: did) value;
							script: [ :s | main updateCenterSideHistory: s ]).
		html break ].
	self indent: indent + self indentIncrement on: html.
	exampleText isString
		ifTrue: [ 
			(html textInput)
				id: (did := html nextId);
				exampleText: exampleText;
				size: maxLength;
				onEnter:
						((html jQuery ajax)
								callback: [ :value | setBlock value: list , {value} ] value: (html jQuery id: did) value;
								script: [ :s | main updateCenterSideHistory: s ]) ]
		ifFalse: [ 
			self
				renderCommand: [ :s :selectedName | 
					setBlock value: list , {selectedName}.
					main updateCenterSideHistory: s ]
				names: exampleText
				label: buttonLabel
				on: html
				main: main ].
	html break! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'DataCurator 07/15/2011 11:30'!
renderNewRepositoryEditor: repositoriesSpec maxLength: max indent: indent on: html main: main
	| id did uid pid textInput description descriptions exampleText maxLength |
	descriptions := self repositoryDescriptions.
	description := Array with: ''."see http://code.google.com/p/glassdb/issues/detail?id=221"
	self indent: indent + self indentIncrement on: html.
	exampleText := 'new repository description'.
	maxLength := max max: exampleText size.
	(textInput := html textInput)
		id: (did := html nextId);
		exampleText: exampleText;
		size: maxLength;
		script:
				(html jQuery this autocomplete
						sourceCallback: [ :term | descriptions select: [ :each | each includesSubstring: term caseSensitive: false ] ]);
		onChange: (html jQuery ajax callback: [ :value | description at: 1 put: value ] value: (html jQuery id: did) value);
		onEnter:
				((html jQuery ajax)
						callback: [ :value | description at: 1 put: value ] value: (html jQuery id: did) value;
						script: [ :s | 
									| repoSpec |
									repoSpec := repositoriesSpec
										detect: [ :repo | repo description = (description at: 1) ]
										ifNone: [ repositoriesSpec repository: (description at: 1) ].
									repoSpec repository: (description at: 1).
									self commit.
									main updateCenterSideHistory: s ]).
	html space.
	html
		small: [ 
			html
				emphasis: [ 
					html text: '('.
					html strong: 'Hint'.
					html text: ': enter repository description and hit Enter key to create new repository spec)' ] ].
	html break! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/7/2011 18:30'!
renderPackageEditor: packageSpecMember on: html main: main
	| indent packageSpec memberType packageNames |
	indent := self renderSectionEditorHeading: self currentSection on: html main: main.
	packageSpec := packageSpecMember spec.
	memberType := self memberTypeFor: packageSpecMember.
	self indent: indent on: html.
	self label: [ html strong: 'packages:' ] on: html.
	html break.
	indent := indent + self indentIncrement.
	self indent: indent on: html.
	self value: [ html strong: packageSpec name ] on: html.
	html small: ' (' , memberType , '): '.
	html break.
	memberType = 'remove'
		ifTrue: [ ^ self ].
	packageNames := (self project attributes includes: self currentSection attribute)
		ifTrue: [ self version projects , self version packages collect: [ :each | each name ] ]
		ifFalse: [ #() ].
	self
		renderFieldEditor: 'file'
		get: [ packageSpec getFile ]
		set: [ :value | 
			packageSpec file: value.
			self commit ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'preLoadDoIt'
		get: [ 
			packageSpec getPreLoadDoIt value
				ifNil: [ '' ]
				ifNotNil: [ :val | 
					val isSymbol
						ifTrue: [ val printString ]
						ifFalse: [ val ] ] ]
		set: [ :value | 
			packageSpec preLoadDoIt: (String fromString: value) asSymbol.
			self commit ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'postLoadDoIt'
		get: [ packageSpec getPostLoadDoIt value ifNil: [ '' ] ifNotNil: [ :val | val printString ] ]
		set: [ :value | 
			packageSpec postLoadDoIt: (String fromString: value) asSymbol.
			self commit ]
		indent: indent
		on: html
		main: main.
	self isBaselineVersion
		ifTrue: [ 
			self
				renderListEditor: packageSpec requires copy
				label: 'requires:'
				buttonLabel: 'require package'
				exampleText:
					(packageNames isEmpty
						ifTrue: [ 'required package/project' ]
						ifFalse: [ 
							| coll |
							coll := packageNames copy.
							coll removeAllFoundIn: packageSpec requires.
							coll remove: packageSpec name ifAbsent: [  ].
							coll ])
				set: [ :requires | 
					packageSpec requires: requires.
					self commit ]
				indent: indent
				on: html
				main: main.
			self
				renderListEditor: packageSpec includes copy
				label: 'includes:'
				buttonLabel: 'include package'
				exampleText:
					(packageNames isEmpty
						ifTrue: [ 'included package/project' ]
						ifFalse: [ 
							| coll |
							coll := packageNames copy.
							coll removeAllFoundIn: packageSpec includes.
							coll remove: packageSpec name ifAbsent: [  ].
							coll ])
				set: [ :includes | 
					packageSpec includes: includes.
					self commit ]
				indent: indent
				on: html
				main: main.
			self
				renderRepositoryEditor: packageSpec repositories
				requiredField: false
				indent: indent
				on: html
				main: main ].
	self renderCommands: self currentSection on: html main: main! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 8/2/2011 14:09'!
renderPackageSpec: packageSpecMember path: path indent: indent on: html main: main
	| blocks packageSpec memberType |
	packageSpec := packageSpecMember spec.
	blocks := OrderedCollection new.
	memberType := self memberTypeFor: packageSpecMember.
	packageSpec getFile
		ifNotNil: [ :s | 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: [ html text: 'file: ' ] value: [ html text: s value ] on: html.
					html break ] ].
	packageSpec requires notEmpty
		ifTrue: [ 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: 'requires: ' on: html.
					packageSpec requires
						do: [ :str | 
							self value: str printString on: html.
							html space ].
					html break ] ].
	packageSpec includes notEmpty
		ifTrue: [ 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: 'includes: ' on: html.
					packageSpec includes
						do: [ :str | 
							self value: str printString on: html.
							html space ].
					html break ] ].
	packageSpec repositories notEmpty
		ifTrue: [ 
			blocks
				add: [ :doIndent :count | 
					self
						renderRepositoriesSpecs: packageSpec
						path: path , {packageSpecMember}
						indent: indent + self indentIncrement
						on: html
						main: main ] ].
	packageSpec getPreLoadDoIt
		ifNotNil: [ :s | 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: [ html text: 'preLoadDoIt: ' ] on: html.
					(html span)
						class: 'symbol';
						with: s value printString.
					html break ] ].
	packageSpec getPostLoadDoIt
		ifNotNil: [ :s | 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: [ html text: 'postLoadDoIt: ' ] on: html.
					(html span)
						class: 'symbol';
						with: s value printString.
					html break ] ].
	packageSpec answers notEmpty
		ifTrue: [ 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: 'supplyingAnswers: ' on: html.
					html text: '#('.
					packageSpec answers
						do: [ :arrayOfArrays | 
							html text: '#('.
							arrayOfArrays
								do: [ :str | 
									self value: str printString on: html.
									html space ].
							html text: ')' ].
					html text: ')'.
					html break ] ].
	self indent: indent on: html.
	self
		renderIntraPageLink: [ :s | 
			self
				aspect: #package;
				aspectPath: path , {packageSpecMember}.
			main updateCenterSideHistory: s ]
		with: [ self value: [ html strong: packageSpec name ] on: html ]
		on: html.
	html small: ' (' , memberType , '): '.
	blocks isEmpty
		ifTrue: [ ^ html break ].
	blocks size > 1
		ifTrue: [ html break ].
	blocks do: [ :block | block value: blocks size > 1 value: indent + self indentIncrement ]! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/29/2011 12:24'!
renderPackagesSpecs: versionSpec path: path indent: indent on: html main: main
	| projectSpecs packageSpecs groupSpecs selected |
	projectSpecs := OrderedCollection new.
	packageSpecs := OrderedCollection new.
	groupSpecs := OrderedCollection new.
	versionSpec packagesSpec list
		do: [ :member | 
			member spec
				projectDo: [ :proj | 
					member spec name ~~ nil
						ifTrue: [ projectSpecs add: member ] ]
				packageDo: [ :package | 
					member spec name ~~ nil
						ifTrue: [ packageSpecs add: member ] ]
				groupDo: [ :group | 
					member spec name ~~ nil
						ifTrue: [ groupSpecs add: member ] ] ].
	selected := nil.
	self aspectPath size >= 2
		ifTrue: [ selected := self aspectPath at: 2 ].
	projectSpecs notEmpty
		ifTrue: [ 
			self indent: indent on: html.
			self label: [ html strong: 'projects: ' ] on: html.
			html break.
			projectSpecs
				do: [ :projectSpecMember | 
					self
						backgroundColor: projectSpecMember = selected
						on: html
						do: [ 
							self
								renderProjectSpec: projectSpecMember
								path: path
								indent: indent + self indentIncrement
								on: html
								main: main ] ] ].
	packageSpecs notEmpty
		ifTrue: [ 
			self indent: indent on: html.
			self label: [ html strong: 'packages: ' ] on: html.
			html break.
			packageSpecs
				do: [ :packageSpecMember | 
					self
						backgroundColor: packageSpecMember = selected
						on: html
						do: [ 
							self
								renderPackageSpec: packageSpecMember
								path: path
								indent: indent + self indentIncrement
								on: html
								main: main ] ] ].
	groupSpecs notEmpty
		ifTrue: [ 
			self indent: indent on: html.
			self label: [ html strong: 'groups: ' ] on: html.
			html break.
			groupSpecs
				do: [ :groupSpecMember | 
					self
						backgroundColor: groupSpecMember = selected
						on: html
						do: [ 
							self
								renderGroupSpec: groupSpecMember
								path: path
								indent: indent + self indentIncrement
								on: html
								main: main ] ] ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/20/2011 12:05'!
renderProjectEditor: projectSpecMember on: html main: main
	| path blocks projectSpec indent projectReferenceSpec memberType projectPackage projectVersion requiredFields |
	indent := self renderSectionEditorHeading: self currentSection on: html main: main.
	projectReferenceSpec := projectSpecMember spec.
	projectSpec := projectReferenceSpec referencedSpec.
	projectSpec ifNotNil: [ projectPackage := projectSpec projectPackage ].
	memberType := self memberTypeFor: projectSpecMember.
	requiredFields := #('merge' 'add') includes: memberType.
	self indent: indent on: html.
	self label: [ html strong: 'projects:' ] on: html.
	html break.
	indent := indent + self indentIncrement.
	self indent: indent on: html.
	self value: [ html strong: projectReferenceSpec name ] on: html.
	memberType = 'copy'
		ifTrue: [ 
			html text: ' copied from '.
			html strong: projectSpecMember sourceName ].
	html small: ' (' , memberType , '): '.
	html break.
	memberType = 'remove'
		ifTrue: [ ^ self ].
	projectVersion := projectReferenceSpec versionOrNil.
	projectSpec
		ifNotNil: [ 
			projectSpecMember methodUpdateSelector == #copy:
				ifFalse: [ 
					self isBaselineVersion
						ifTrue: [ 
							self
								renderFieldEditor:
									'className'
										,
											(requiredFields
												ifTrue: [ '*' ]
												ifFalse: [ '' ])
								get: [ projectSpec className ]
								set: [ :value | 
									projectReferenceSpec className: value.
									self commit ]
								indent: indent
								on: html
								main: main.
							self
								renderFieldEditor: 'file'
								get: [ projectSpec file ]
								set: [ :value | 
									projectReferenceSpec file: value.
									self commit ]
								indent: indent
								on: html
								main: main ].
					self
						renderFieldEditor:
							'versionString'
								,
									(requiredFields
										ifTrue: [ '*' ]
										ifFalse: [ '' ])
						get: [ 
							projectSpec versionString
								ifNil: [ '' ]
								ifNotNil: [ :val | 
									val isSymbol
										ifTrue: [ val printString ]
										ifFalse: [ val ] ] ]
						set: [ :value | 
							projectSpec versionString: (String fromString: value).
							self commit ]
						indent: indent
						on: html
						main: main ].
			self isBaselineVersion
				ifTrue: [ 
					self
						renderFieldEditor: 'operator'
						get: [ projectSpec getOperator value ]
						set: [ :value | 
							projectSpec operator: value.
							self commit ]
						indent: indent
						on: html
						main: main ].
			self
				renderFieldEditor: 'preLoadDoIt'
				get: [ projectSpec getPreLoadDoIt value ifNil: [ '' ] ifNotNil: [ :val | val printString ] ]
				set: [ :value | 
					projectSpec preLoadDoIt: (String fromString: value) asSymbol.
					self commit ]
				indent: indent
				on: html
				main: main.
			self
				renderFieldEditor: 'postLoadDoIt'
				get: [ projectSpec getPostLoadDoIt value ifNil: [ '' ] ifNotNil: [ :val | val printString ] ]
				set: [ :value | 
					projectSpec postLoadDoIt: (String fromString: value) asSymbol.
					self commit ]
				indent: indent
				on: html
				main: main.
			self isBaselineVersion
				ifTrue: [ 
					self
						renderListEditor: projectSpec loads copy
						label: 'loads:'
						buttonLabel: 'add load package'
						exampleText:
							(projectVersion
								ifNil: [ 'package/project/group name' ]
								ifNotNil: [ :ver | 
									| names |
									names := (ver projects , ver packages , ver groups collect: [ :each | each name ]) sorted.
									names removeAllFoundIn: (projectSpec loads ifNil: [ #() ]).
									names ])
						set: [ :loads | 
							projectSpec loads: loads.
							self commit ]
						indent: indent
						on: html
						main: main.
					projectSpecMember methodUpdateSelector == #copy:
						ifFalse: [ 
							self
								renderRepositoryEditor:
									(projectPackage isNil
										ifTrue: [ #() ]
										ifFalse: [ projectPackage repositories ])
								requiredField: requiredFields
								indent: indent
								on: html
								main: main ] ] ].
	html small: '* required fields'.
	self renderCommands: self currentSection on: html main: main! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 8/2/2011 14:08'!
renderProjectSpec: projectSpecMember path: path indent: indent on: html main: main
	| blocks projectSpec projectReferenceSpec memberType projectPackage |
	blocks := OrderedCollection new.
	projectSpec := projectSpecMember spec.
	projectReferenceSpec := projectSpec referencedSpec.
	projectReferenceSpec ifNotNil: [ projectPackage := projectReferenceSpec projectPackage ].
	memberType := self memberTypeFor: projectSpecMember.
	projectReferenceSpec
		ifNotNil: [ 
			projectReferenceSpec className
				ifNotNil: [ :className | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: [ html text: 'className: ' ] value: [ html text: className printString ] on: html.
							html break ].
					projectReferenceSpec file
						ifNotNil: [ :file | 
							file ~= className
								ifTrue: [ 
									blocks
										add: [ :doIndent :count | 
											doIndent
												ifTrue: [ self indent: count on: html ].
											self label: [ html text: 'file: ' ] value: [ html text: file printString ] on: html.
											html break ] ] ] ].
			projectReferenceSpec versionString
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: [ html text: 'versionString: ' ] value: [ html text: s printString ] on: html.
							html break ] ].
			projectReferenceSpec getOperator
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: [ html text: 'operator: ' ] on: html.
							(html span)
								class: 'symbol';
								with: s printString.
							html break ] ].
			projectReferenceSpec getPreLoadDoIt
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: [ html text: 'preLoadDoIt: ' ] on: html.
							(html span)
								class: 'symbol';
								with: s value printString.
							html break ] ].
			projectReferenceSpec getPostLoadDoIt
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: [ html text: 'postLoadDoIt: ' ] on: html.
							(html span)
								class: 'symbol';
								with: s value printString.
							html break ] ].
			projectReferenceSpec loads
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifFalse: [ html break ].
							self
								renderList: projectReferenceSpec loads
								label: 'loads:'
								indent: indent + self indentIncrement
								on: html
								main: main ] ].
			projectPackage
				ifNotNil: [ 
					projectPackage repositories notEmpty
						ifTrue: [ 
							blocks
								add: [ :doIndent :count | 
									self
										renderRepositoriesSpecs: projectPackage
										path: path , {projectSpecMember}
										indent: indent + self indentIncrement
										on: html
										main: main ] ] ] ].
	self indent: indent on: html.
	self
		renderIntraPageLink: [ :s | 
			self
				aspect: #project;
				aspectPath: path , {projectSpecMember}.
			main updateCenterSideHistory: s ]
		with: [ self value: [ html strong: projectSpec name ] on: html ]
		on: html.
	memberType = 'copy'
		ifTrue: [ 
			html text: ' copied from '.
			html strong: projectSpecMember sourceName ].
	html small: ' (' , memberType , '): '.
	blocks isEmpty
		ifTrue: [ ^ html break ].
	blocks size > 1
		ifTrue: [ html break ].
	blocks do: [ :block | block value: blocks size > 1 value: indent + self indentIncrement ]! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/29/2011 12:21'!
renderRepositoriesSpecs: versionSpec path: path indent: indent on: html main: main
	| spec |
	spec := versionSpec repositories.
	spec isEmpty
		ifTrue: [ ^ self ].
	self indent: indent on: html.
	self label: [ html text: 'repositories:' ] on: html.
	html break.
	spec
		do: [ :repoSpec | 
			self indent: indent + self indentIncrement on: html.
			self renderRepositorySpec: repoSpec on: html main: main.
			html break ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/5/2011 17:28'!
renderRepositoryEditor: repositoriesSpec indent: indent on: html main: main
	| maxLength |
	self indent: indent on: html.
	self label: [ html strong: 'repositories*:' ] on: html.
	html break.
	maxLength := 0.
	repositoriesSpec do: [ :repoSpec | maxLength := maxLength max: repoSpec description size ].
	repositoriesSpec
		do: [ :repoSpec | 
			| did uid pid textInput |
			self indent: indent + self indentIncrement on: html.
			(html textInput)
				id: (did := html nextId);
				value: repoSpec description value;
				size: maxLength;
				onEnter:
						((html jQuery ajax)
								callback: [ :value | 
											value isEmpty
												ifTrue: [ repositoriesSpec remove: repoSpec copy ]
												ifFalse: [ repoSpec description: value ] ]
									value: (html jQuery id: did) value;
								script: [ :s | main updateCenterSideHistory: s ]).
			html space.
			(textInput := html textInput)
				id: (uid := html nextId);
				onEnter:
						((html jQuery ajax)
								callback: [ :value | repoSpec username: value ] value: (html jQuery id: uid) value;
								script: [ :s | main updateCenterSideHistory: s ]).
			repoSpec username isEmpty
				ifTrue: [ textInput exampleText: 'username' ]
				ifFalse: [ textInput value: repoSpec username ].
			html space.
			(textInput := html passwordInput)
				id: (pid := html nextId);
				onEnter:
						((html jQuery ajax)
								callback: [ :value | repoSpec password: value ] value: (html jQuery id: pid) value;
								script: [ :s | main updateCenterSideHistory: s ]).
			repoSpec password isEmpty
				ifTrue: [ textInput exampleText: 'password' ]
				ifFalse: [ textInput value: repoSpec password ].
			html break ].
	self
		renderNewRepositoryEditor: repositoriesSpec
		maxLength: maxLength
		indent: indent
		on: html
		main: main! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/5/2011 18:03'!
renderRepositoryEditor: repositoriesSpec requiredField: requiredField indent: indent on: html main: main
	| maxLength |
	self indent: indent on: html.
	requiredField
		ifTrue: [ self label: [ html strong: 'repositories*:' ] on: html ]
		ifFalse: [  self label: [ html strong: 'repositories:' ] on: html ].
	html break.
	maxLength := 0.
	repositoriesSpec do: [ :repoSpec | maxLength := maxLength max: repoSpec description size ].
	repositoriesSpec
		do: [ :repoSpec | 
			| did uid pid textInput |
			self indent: indent + self indentIncrement on: html.
			(html textInput)
				id: (did := html nextId);
				value: repoSpec description value;
				size: maxLength;
				onEnter:
						((html jQuery ajax)
								callback: [ :value | 
											value isEmpty
												ifTrue: [ repositoriesSpec remove: repoSpec copy ]
												ifFalse: [ repoSpec description: value ] ]
									value: (html jQuery id: did) value;
								script: [ :s | main updateCenterSideHistory: s ]).
			html space.
			(textInput := html textInput)
				id: (uid := html nextId);
				onEnter:
						((html jQuery ajax)
								callback: [ :value | repoSpec username: value ] value: (html jQuery id: uid) value;
								script: [ :s | main updateCenterSideHistory: s ]).
			repoSpec username isEmpty
				ifTrue: [ textInput exampleText: 'username' ]
				ifFalse: [ textInput value: repoSpec username ].
			html space.
			(textInput := html passwordInput)
				id: (pid := html nextId);
				onEnter:
						((html jQuery ajax)
								callback: [ :value | repoSpec password: value ] value: (html jQuery id: pid) value;
								script: [ :s | main updateCenterSideHistory: s ]).
			repoSpec password isEmpty
				ifTrue: [ textInput exampleText: 'password' ]
				ifFalse: [ textInput value: repoSpec password ].
			html break ].
	self
		renderNewRepositoryEditor: repositoriesSpec
		maxLength: maxLength
		indent: indent
		on: html
		main: main! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/28/2011 15:52'!
renderRepositorySpec: repositorySpec on: html main: main
	self value: [ html text: repositorySpec description ] on: html.
	(repositorySpec username isEmpty not or: [ repositorySpec password isEmpty not ])
		ifTrue: [ 
			self label: [ html text: ' username: ' ] value: [ html text: repositorySpec username printString ] on: html.
			self label: [ html text: ' password: ' ] value: [ html text: '****' ] on: html ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/5/2011 10:32'!
renderSectionEditor: section on: html main: main
	| indent |
	indent := self renderSectionEditorHeading: section on: html main: main.
	self
		renderVersionSpecEditor: section versionSpec
		path: {section}
		indent: indent + self indentIncrement
		on: html
		main: main.
	self renderCommands: section on: html main: main! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 14:51'!
renderSectionEditorHeading: section on: html main: main
	| vms indent |
	vms := self versionMethodSpec.
	self label: [ html text: 'version: ' ] on: html.
	html strong: vms versionString.
	vms imports notEmpty
		ifTrue: [ 
			html space.
			self label: [ html text: 'imports: ' ] on: html.
			vms imports
				do: [ :import | 
					self
						renderLink: [ :s | 
							self currentSession push: (self mbVersionInfo configurationInfo infoFor: import) selecting: #view.
							main updateCenterSideHistory: s ]
						with: [ html strong: import ]
						on: html.
					html space ] ].
	html break.
	indent := self indentIncrement.
	self indent: indent on: html.
	(html span)
		class: 'symbol';
		with: [ html text: section attribute printString ].
	html break.
	^ indent! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/29/2011 12:25'!
renderVersionSpec: spec path: path indent: indent on: html main: main
	self
		backgroundColor: (self aspectPath notEmpty and: [ path first = self aspectPath first ])
		on: html
		do: [ 
			spec getBlessing
				ifNotNil: [ 
					self indent: indent on: html.
					self label: [ html text: 'blessing: ' ] on: html.
					(html span)
						class: 'symbol';
						with: spec blessing value printString.
					html break ].
			spec getDescription
				ifNotNil: [ 
					self indent: indent on: html.
					self label: [ html text: 'description: ' ] on: html.
					self
						renderLink: [ :s | 
							self currentSession push: spec description value selecting: #view.
							main updateCenterSideHistory: s ]
						with: [ self value: [ html text: (spec description value printStringLimitedTo: 25) ] on: html ]
						on: html.
					html break ].
			spec getAuthor
				ifNotNil: [ 
					self indent: indent on: html.
					self label: [ html text: 'author: ' ] value: [ html text: spec author value ] on: html.
					html break ].
			spec getTimestamp
				ifNotNil: [ 
					self indent: indent on: html.
					self label: [ html text: 'timestamp: ' ] value: [ html text: spec timestamp value ] on: html.
					html break ].
			spec getPreLoadDoIt
				ifNotNil: [ 
					self indent: indent on: html.
					self label: [ html text: 'preLoadDoIt: ' ] on: html.
					(html span)
						class: 'symbol';
						with: spec preLoadDoIt value printString.
					html break ].
			spec getPostLoadDoIt
				ifNotNil: [ 
					self indent: indent on: html.
					self label: [ html text: 'postLoadDoIt: ' ] on: html.
					(html span)
						class: 'symbol';
						with: spec postLoadDoIt value printString.
					html break ].
			self
				renderRepositoriesSpecs: spec
				path: path
				indent: indent
				on: html
				main: main ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/6/2011 05:58'!
renderVersionSpecEditor: spec path: path indent: indent on: html main: main
	self
		renderFieldEditor: 'blessing'
		get: [ spec getBlessing value ifNil: [ '' ] ifNotNil: [ :val | val printString ] ]
		set: [ :value | 
			spec blessing: (String fromString: value) asSymbol.
			self commit ]
		indent: indent
		on: html
		main: main.
	self indent: indent on: html.
	self label: [ html text: 'description: ' ] on: html.
	self
		renderLink: [ :s | 
			self aspect: #description.
			main updateCenterSideHistory: s ]
		with: [ self value: [ html text: (spec description value printStringLimitedTo: 25) ] on: html ]
		on: html.
	html small: ' (Hint: click to open editor)'.
	html break.
	self
		renderFieldEditor: 'author'
		get: [ spec getAuthor value ]
		set: [ :value | 
			spec author: value.
			self commit ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'timestamp'
		get: [ spec getTimestamp value ]
		set: [ :value | 
			spec timestamp: value.
			self commit ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'preLoadDoIt'
		get: [ spec getPreLoadDoIt value ifNil: [ '' ] ifNotNil: [ :val | val printString ] ]
		set: [ :value | 
			spec preLoadDoIt: (String fromString: value) asSymbol.
			self commit ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'postLoadDoIt'
		get: [ spec getPostLoadDoIt value ifNil: [ '' ] ifNotNil: [ :val | val printString ] ]
		set: [ :value | 
			spec postLoadDoIt: (String fromString: value) asSymbol.
			self commit ]
		indent: indent
		on: html
		main: main.
	self
		renderRepositoryEditor: spec repositoriesSpec
		requiredField: false
		indent: indent
		on: html
		main: main! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 7/6/2011 17:40'!
renderVersionSummaryCommandsOn: html main: main
	"noop"

	! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 08/04/2011 16:34'!
renderVersionSummaryOn: html main: main
	| list cv cvs |
	self renderVersionSummaryCommandsOn: html main: main.
	cv := self mbVersionInfo.
	cv ifNil: [ ^ self ].
	cvs := cv versionString.
	(html span)
		class: 'naviode';
		with: [ 
					(list := cv projects) notEmpty
						ifTrue: [ 
							html text: ' -- ' , cvs , ' projects --'.
							html
								break;
								break.
							list
								do: [ :info | 
									| projectConfig |
									(projectConfig := info projectConfiguration) notNil
										ifTrue: [ 
											self
												renderLink: [ :s | 
													self currentSession push: projectConfig selecting: #view.
													main updateCenterSideHistory: s ]
												with: [ info renderLabelOn: html main: main ]
												on: html ]
										ifFalse: [ info renderLabelOn: html main: main ].
									html break ].
							html break ].
					(list := cv packages) notEmpty
						ifTrue: [ 
							html text: ' -- ' , cvs , ' packages --'.
							html
								break;
								break.
							list
								do: [ :info | 
									info workingCopy
										ifNil: [ info renderLabelOn: html main: main ]
										ifNotNil: [ 
											self
												renderLink: [ :s | 
													self currentSession push: info selecting: #view.
													main updateCenterSideHistory: s ]
												with: [ info renderLabelOn: html main: main ]
												on: html ].
									html break ].
							html break ].
					(list := cv groups) notEmpty
						ifTrue: [ 
							html text: ' -- ' , cvs , ' groups --'.
							html
								break;
								break.
							list
								do: [ :info | 
									info renderLabelOn: html main: main.
									html break ].
							html break ] ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/6/2011 12:33'!
renderViewContentOn: html main: main
	advancedSearch ifNotNil: [ ^ self renderAdvancedSearchResultsOn: html main: main ].
	configurationSearchResults ifNotNil: [ ^ self renderSearchResultsOn: html main: main ].
	^ (html span)
		class: 'shout';
		with: [ 
					self aspect == #description
						ifTrue: [ self renderDescriptionEditor: self selectedAspect on: html main: main ].
					self aspect == #section
						ifTrue: [ self renderSectionEditor: self selectedAspect on: html main: main ].
					self aspect == #project
						ifTrue: [ self renderProjectEditor: self selectedAspect on: html main: main ].
					self aspect == #package
						ifTrue: [ self renderPackageEditor: self selectedAspect on: html main: main ].
					self aspect == #group
						ifTrue: [ self renderGroupEditor: self selectedAspect on: html main: main ].
					self aspect == #versionMethodSpec
						ifTrue: [ self renderVersionSummaryOn: html main: main ] ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/7/2011 16:18'!
repositoryDescriptions
	^ (self repositories collect: [ :repo | (repo asRepositorySpecFor: self project) description ]) sorted! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 17:00'!
selectedAspect
	self aspectPath isEmpty
		ifTrue: [ ^ nil ].
	^ self aspectPath last! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 17:16'!
tODEVersionSidebarSpec
	^ {((TOTabSpec new)
		id: #versionSpec;
		renderer:
				((TOVersionSidebar new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'version spec';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}
! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:27'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: self;
		sidebarSpec: self tODEVersionSidebarSpec;
		yourself! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:42'!
value: valueBlock on: html
	self label: nil value: valueBlock on: html
! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 08/04/2011 16:30'!
version
	self mbVersionInfo ifNil: [ ^ nil ].
	^ self mbVersionInfo version! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/24/2011 15:18'!
versionMethodSpec
	versionMethodSpec ifNil: [ versionMethodSpec := self createVersionMethodSpec ].
	^ versionMethodSpec! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/24/2011 15:17'!
versionMethodSpec: anObject
	versionMethodSpec := anObject! !

TOAbstractVersion subclass: #TOBaselineVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOBaselineVersion methodsFor: 'testing' stamp: 'dkh 7/7/2011 07:52'!
isBaselineVersion
	^ true! !

!TOBaselineVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/7/2011 15:55'!
renderAddGroup: section on: html main: main
	self
		renderCommand: [ :s :string | 
			| spec groupSpec |
			groupSpec := (self project groupSpec)
				name: string;
				yourself.
			section versionSpec packages merge: groupSpec.
			self commit.
			aspect := #group.
			aspectPath := aspectPath , {(section versionSpec packages list detect: [ :member | member spec name = string ])} ]
		exampleText: 'group name'
		label: 'add Group'
		on: html
		main: main.
	html break! !

!TOBaselineVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/7/2011 15:57'!
renderAddPackage: section on: html main: main
	| packageList |
	packageList := (MCWorkingCopy allManagers collect: [ :wc | wc packageName ]) sorted.
	self
		renderCommand: [ :s :string | 
			| spec packageSpec |
			packageSpec := (self project packageSpec)
				name: string;
				yourself.
			section versionSpec packages merge: packageSpec.
			self commit.
			aspect := #package.
			aspectPath := aspectPath , {(section versionSpec packages list detect: [ :member | member spec name = string ])} ]
		names: packageList
		label: 'add Package'
		on: html
		main: main.
	html break! !

!TOBaselineVersion methodsFor: 'rendering-editor' stamp: 'dkh 07/20/2011 15:37'!
renderAddProject: section on: html main: main
	| configurations projectNames |
	configurations := MBConfigurationRoot current configurations.
	projectNames := configurations collect: [ :config | MetacelloToolBox baseNameOf: config name ].
	self
		renderCommand: [ :s :string | 
			| spec projectSpec config projectReferenceProject |
			config := configurations at: (projectNames indexOf: string).
			projectReferenceProject := config configurationClass project.
			projectSpec := (self project projectSpec)
				name: string;
				projectPackage: projectReferenceProject packageSpec;
				className: config configurationClass name asString;
				repository: projectReferenceProject projectPackage repositorySpecs first description;
				versionString:
						((projectReferenceProject hasVersion: #stable)
								ifTrue: [ #stable ]
								ifFalse: [ #bleedingEdge ]).
			spec := (self project projectReferenceSpec)
				name: string;
				projectReference: projectSpec;
				yourself.
			section versionSpec packages merge: spec.
			self commit.
			aspect := #project.
			aspectPath := aspectPath , {(section versionSpec packages list detect: [ :member | member spec name = string ])} ]
		names: projectNames
		label: 'add Project'
		on: html
		main: main.
	html break! !

!TOBaselineVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/7/2011 15:55'!
renderAddSectionOn: html main: main
	self
		renderCommand: [ :s :string | 
			self versionMethodSpec addMethodSection: string asSymbol versionSpec: self project versionSpec.
			self commit ]
		exampleText: 'section name'
		label: 'add Section'
		on: html
		main: main.
	html break! !

!TOBaselineVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/6/2011 07:13'!
renderCommands: section on: html main: main
	html horizontalRule.
	html horizontalRule.
	self renderAddSectionOn: html main: main.
	self renderAddPackage: section on: html main: main.
	self renderAddProject: section on: html main: main.
	self renderCopyProject: section on: html main: main.
	self renderAddGroup: section on: html main: main.
	html horizontalRule.
	self renderSearchCommandOn: html main: main.
	html break! !

!TOBaselineVersion methodsFor: 'rendering-editor' stamp: 'dkh 7/6/2011 08:07'!
renderCopyProject: section on: html main: main
	| configurations projectNames projectName id commandBlock sid selectedIndex |
	configurations := MBConfigurationRoot current configurations.
	projectNames := self version projects collect: [ :each | each name ].
	commandBlock := [ :s :string | 
	| spec projectSpec projectReferenceProject |
	projectReferenceProject := self mbConfigurationInfo configurationClass project.
	projectSpec := (self project projectSpec)
		name: projectName;
		yourself.
	spec := (self project projectReferenceSpec)
		name: projectName;
		projectReference: projectSpec;
		yourself.
	section versionSpec packages copy: string to: spec.
	self commit.
	aspect := #project.
	aspectPath := aspectPath , {(section versionSpec packages list detect: [ :member | member spec name = string ])} ].
	selectedIndex := 1.
	self
		renderButton: [ :s | 
			commandBlock value: s value: (projectNames at: selectedIndex asInteger).
			main updateCenterSideHistory: s ]
		label: 'copy Project'
		on: html.
	html space.
	(html textInput)
		id: (id := html nextId);
		exampleText: 'project name';
		value: projectName;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | projectName := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									commandBlock value: s value: projectName.
									main updateCenterSideHistory: s ]);
		onChange: (html jQuery ajax callback: [ :value | projectName := value ] value: (html jQuery id: id) value).
	html text: ' copied from '.
	(html select)
		id: (sid := html nextId);
		list: projectNames;
		callback: [ :value | selectedIndex := value ];
		onChange: (html jQuery ajax callback: [ :value | selectedIndex := value ] value: (html jQuery id: sid) value).
	html break! !

!TOBaselineVersion methodsFor: 'rendering-spec' stamp: 'dkh 7/10/2011 13:26'!
renderVersionSummaryCommandsOn: html main: main
	self renderAddBaselineCommandUsing: self version on: html main: main.
	html text: ' based on version ' , self version versionString printString.
	html break.
	self renderAddDevelopmentVersionCommandImporting: self version on: html main: main.
	html text: ' importing version ' , self version versionString printString.
	html horizontalRule.
	html horizontalRule! !

TOAbstractVersion subclass: #TOVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOVersion methodsFor: 'testing' stamp: 'dkh 7/7/2011 07:51'!
isVersion
	^ true! !

!TOVersion methodsFor: 'rendering-spec' stamp: 'dkh 7/7/2011 16:19'!
renderArchiveVersionCommandOn: html main: main
	| descriptions repositories |
	repositories := self repositories.
	descriptions := repositories collect: [ :each | each description ].
	self
		renderCommand: [ :s :archiveRepository | 
			| version |
			(archiveRepository respondsTo: #flushCache)
				ifTrue: [ archiveRepository perform: #flushCache ].
			self mbConfigurationInfo project projectPackage
				copySpecTo: (archiveRepository asRepositorySpecFor: self mbConfigurationInfo project).
			version := self version.
			version cacheRepository: archiveRepository.
			version ignoreImage: true.
			version fetch: 'ALL'.
			main updateCenterSideHistory: s ]
		names: descriptions
		values: repositories
		label: 'archive version'
		on: html
		main: main! !

!TOVersion methodsFor: 'rendering-spec' stamp: 'dkh 07/24/2011 10:04'!
renderLoadVersionCommandOn: html main: main
	self
		renderButton: [ :s | 
			self deploy: [ self version load ].
			self refresh.
			main updateCenterSideHistory: s ]
		label: 'load'
		on: html! !

!TOVersion methodsFor: 'rendering-spec' stamp: 'DataCurator 07/13/2011 15:27'!
renderUpdatePackagesCommandOn: html main: main
	self
		renderButton: [ :s | 
			MetacelloToolBox
				updateDevelopment: self version versionString
				for: self mbVersionInfo configurationBasename
				updateProjects: false
				description: ''.
			self refresh.
			main updateCenterSideHistory: s ]
		label: 'update packages'
		on: html! !

!TOVersion methodsFor: 'rendering-spec' stamp: 'DataCurator 07/13/2011 10:57'!
renderUpdateProjectsCommandOn: html main: main
	self
		renderButton: [  :s | 
			MetacelloToolBox
				updateDevelopment: self version versionString
				for: self mbVersionInfo configurationBasename
				updatePackages: false
				description: ''.
			main updateCenterSideHistory: s ]
		label: 'update projects'
		on: html! !

!TOVersion methodsFor: 'rendering-spec' stamp: 'dkh 08/04/2011 16:18'!
renderVersionSummaryCommandsOn: html main: main
	self version ifNil: [ ^ self ].
	self renderAddDevelopmentVersionCommandUsing: self version on: html main: main.
	html text: ' based on version ' , self version versionString printString.
	html break.
	self renderArchiveVersionCommandOn: html main: main.
	html break.
	self renderLoadVersionCommandOn: html main: main.
	html break.
	self renderRemoveVersionCommandOn: html main: main.
	html break.
	self renderUpdatePackagesCommandOn: html main: main.
	html break.
	self renderUpdateProjectsCommandOn: html main: main.
	html horizontalRule.
	html horizontalRule! !

TOMetacelloView subclass: #TOConfiguration
	instanceVariableNames: 'mbConfigurationInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOConfiguration subclass: #TOArchivedConfiguration
	instanceVariableNames: 'archiveRepository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOArchivedConfiguration methodsFor: 'accessing' stamp: 'dkh 7/7/2011 21:38'!
archiveRepository
	^archiveRepository! !

!TOArchivedConfiguration methodsFor: 'accessing' stamp: 'dkh 7/7/2011 21:38'!
archiveRepository: aRepository
	archiveRepository := aRepository! !

!TOArchivedConfiguration methodsFor: 'rendering' stamp: 'dkh 7/7/2011 22:36'!
renderContentOn: html main: main
	(html heading)
		level: 3;
		with: self mbConfigurationInfo printString.
	html strong: 'configuration: '.
	self
		renderLink: [ :s | 
			self currentSession push: self mbConfigurationInfo selecting: #view.
			main updateCenterSideHistory: s ]
		with: [ self mbConfigurationInfo renderStyledLabelOn: html main: main ]
		on: html.
	html horizontalRule.
	html text: 'Select a version to be loaded from the archive repository: '.
	html strong: self archiveRepository description.
	html text: '.'.
	html horizontalRule.
	(html span)
		class: 'naviode';
		with: [ 
					self mbConfigurationInfo versions
						do: [ :info | 
							(info isKindOf: MBAbstractVersionInfo)
								ifTrue: [ 
									self
										renderButton: [ :s | 
											| version |
											version := info version.
											version repositoryOverrides: {(self archiveRepository)}.
											version load ]
										label: 'load'
										on: html.
									html space.
									self
										renderLink: [ :s | 
											self currentSession push: info selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ info renderLabelOn: html main: main ]
										on: html ].
							html break ] ]! !

!TOArchivedConfiguration methodsFor: 'accessing' stamp: 'dkh 7/7/2011 21:57'!
tODEViewTabSpec
	<tODECenterTabSpec>
	^ (super tODEViewTabSpec)
		renderer: self;
		sidebarSpec: nil;
		yourself! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/22/2011 10:01'!
classList
	| cv |
	self mbConfigurationInfo ifNil: [ ^ #() ].
	(cv := self mbConfigurationInfo currentVersion) ifNil: [ ^ #() ].
	^ cv currentlyLoadedClassesInVersion! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/22/2011 10:09'!
extensionClassList
	| cv |
	self mbConfigurationInfo ifNil: [ ^ Dictionary new ].
	(cv := self mbConfigurationInfo currentVersion) ifNil: [ ^ Dictionary new ].
	^ cv  currentlyLoadedExtensionClassesInVersion! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:33'!
mbConfigurationInfo
	mbConfigurationInfo
		ifNil: [ 
			| wc |
			MCWorkingCopy registry
				do: [ :mgr | 
					(mgr packageInfo includesClass: self actualClass)
						ifTrue: [ wc := mgr ] ].
			wc ifNil: [ ^nil ].
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = wc packageName
								ifTrue: [ 
									mbConfigurationInfo := config.
									^ config ] ] ] ].
	^ mbConfigurationInfo! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 11:06'!
mbConfigurationInfo: anObject
	mbConfigurationInfo := anObject! !

!TOConfiguration methodsFor: 'printing' stamp: 'dkh 6/17/2011 04:37'!
printOn: aStream

super printOn: aStream.
aStream nextPut: $(;
nextPutAll: self mbConfigurationInfo printString;
nextPut: $)! !

!TOConfiguration methodsFor: 'rendering' stamp: 'DataCurator 07/15/2011 11:50'!
renderCheckpointCommandOn: html main: main
	| label |
	self workingCopy ifNil: [ ^ self ].
	label := 'save project'.
	self mbConfigurationInfo isDirty
		ifTrue: [ label := '* ' , label ].
	self
		renderButton: [ :s | 
			self
				pushit:
					((TOCheckpointSaveView new)
						mbConfigurationInfo: mbConfigurationInfo;
						parent: self;
						yourself)
				selecting: #view
				main: main.
			main updateCenterSideHistory: s ]
		label: label
		on: html! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 7/24/2011 08:39'!
renderCommandsOn: html main: main
	html strong: 'Configuration:'.
	html
		unorderedList: [ 
			| baselineVersion linearVersion cv |
			self renderAddEmptyBaselineCommandOn: html main: main.
			html break.
			(baselineVersion := self mbConfigurationInfo project latestVersion: #baseline)
				ifNotNil: [ 
					self
						renderAddBaselineCommandUsing: baselineVersion
						label: 'add baseline version'
						on: html
						main: main.
					html text: ' based on baseline ' , baselineVersion versionString printString.
					html break.
					self
						renderAddDevelopmentVersionCommandImporting: baselineVersion
						label: 'add development version'
						on: html
						main: main.
					html text: ' importing baseline ' , baselineVersion versionString printString.
					html break ].
			(linearVersion := self latestLinearVersion)
				ifNotNil: [ 
					self
						renderAddDevelopmentVersionCommandUsing: linearVersion
						label: 'add development version'
						on: html
						main: main.
					html text: ' based on version ' , linearVersion versionString printString.
					html break ].
			self mbConfigurationInfo isDirty
				ifTrue: [ 
					html break.
					self renderConfigurationChangesCommandOn: html main: main.
					(self mbConfigurationInfo currentVersion notNil and: [ self workingCopy notNil ])
						ifTrue: [ 
							html break.
							self renderCheckpointCommandOn: html main: main ] ].
			((cv := self mbConfigurationInfo currentVersion) notNil and: [ cv blessing == #development ])
				ifTrue: [ 
					html break.
					self renderUpgradeCurrentVersionCommandOn: html main: main ].
			html break.
			self renderValidateConfigurationCommandOn: html main: main ].
	html strong: 'Configuration Package:'.
	html
		unorderedList: [ 
			self workingCopy
				ifNil: [ 
					self
						renderAddPackageCommand: self mbConfigurationInfo configurationClass name asString
						label: 'create Configuration Package'
						on: html
						main: main ]
				ifNotNil: [ 
					self renderPackageChangesCommandOn: html main: main.
					self renderPackageHistoryCommandOn: html main: main.
					self renderRevertCommandOn: html main: main.
					html break.
					self renderSavePackageCommandOn: html main: main.
					html break.
					self renderUnloadPackageCommandsOn: html main: main ] ]! !

!TOConfiguration methodsFor: 'rendering-package changes' stamp: 'DataCurator 07/18/2011 11:25'!
renderConfigurationChangesCommandOn: html main: main
	| wc label |
	label := 'project changes'.
	self mbConfigurationInfo isDirty
		ifTrue: [ label := '* ' , label ].
	self
		renderButton: [ :s | 
			| patches searchResults nameMap count parentCollection linkedItems |
			patches := OrderedCollection new.
			nameMap := IdentityDictionary new.
			(self mbConfigurationInfo packages
				select: [ :mbPackageInfo | (wc := mbPackageInfo workingCopy) notNil and: [ wc ancestors notEmpty and: [ wc modified ] ] ])
				do: [ :mbPackageInfo | 
					| repos names selectedName patch toPatch patchLabel |
					wc := mbPackageInfo workingCopy.
					repos := wc repositoryGroup repositories.
					names := repos collect: [ :r | r description ].
					selectedName := names first.
					patch := wc changesRelativeToRepository: (repos at: (names indexOf: selectedName)).
					patchLabel := 'Changes for ' , mbPackageInfo printString , ' (' , patch operations size printString , ' changes)'.
					toPatch := (TOPatch new)
						object: patch;
						patchLabel: patchLabel;
						yourself.
					nameMap at: toPatch put: patchLabel.
					patch isEmpty
						ifTrue: [ wc modified: false ]
						ifFalse: [ wc modified: true ].
					patches add: toPatch ].
			linkedItems := OrderedCollection new.
			parentCollection := (TOCollection new)
				directItemLink: true;
				collection: linkedItems;
				printStringBlock: [ :item | item itemLabel ];
				label: 'Changes for: ' , self mbConfigurationInfo printString.
			count := 0.
			searchResults := self
				linkedItemsFor: patches
				withViewerDo: [ :item :viewer | 
					count := count + 1.
					viewer
						parent: parentCollection;
						parentLabel: parentCollection label;
						label: count printString , ' of ' , patches size printString;
						itemLabel: (nameMap at: item).
					linkedItems add: viewer ].
			self currentSession push: searchResults selecting: #view.
			main updateCenterSideHistory: s ]
		label: label
		on: html! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 08/04/2011 17:13'!
renderContentOn: html main: main
	self mbConfigurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			html break.
			self renderCreateProjectCommandOn: html main: main.
			^ self ].
	self renderCommandsOn: html main: main! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 7/7/2011 06:33'!
renderFrameTitleOn: html main: main
	| cl |
	self mbConfigurationInfo ifNil: [ ^ super renderFrameTitleOn: html main: main ].
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	(html span)
		class: 'naviode';
		with: [ 
					self mbConfigurationInfo renderStyledLabelOn: html main: main.
					html space.
					html small: '(' , cl name , ')' ]! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 07/24/2011 10:23'!
renderUpgradeCurrentVersionCommandOn: html main: main
	| cv |
	(cv := self mbConfigurationInfo currentVersion) ifNil: [ ^ self ].
	cv blessing ~~ #development
		ifTrue: [ ^ self ].
	self
		renderButton: [ :s | 
			| configClass modifiedPkgDirectives wc fetchingLoader loadBlock version |
			configClass := self mbConfigurationInfo configurationClass.
			configClass project updateProject.
			version := self mbConfigurationInfo version.
			loadBlock := [ self deploy: [ version load ] ].
			(version packages detect: [ :each | (wc := each workingCopy) notNil and: [ wc modified ] ] ifNone: [  ]) isNil
				ifTrue: [ loadBlock value ]
				ifFalse: [ 
					modifiedPkgDirectives := OrderedCollection new.
					(fetchingLoader := version fetch) loadDirective
						packageDirectivesDo: [ :pkgDirective | 
							((wc := pkgDirective spec workingCopy) notNil and: [ wc modified ])
								ifTrue: [ modifiedPkgDirectives add: pkgDirective ] ].
					modifiedPkgDirectives isEmpty
						ifTrue: [ self deploy: [ fetchingLoader doLoad ] ]
						ifFalse: [ 
							self
								pushit:
									((TOMetacelloUpgradeVersionView new)
										parent: self;
										modifiedPkgDirectives: modifiedPkgDirectives;
										loadBlock: [ self deploy: [ fetchingLoader doLoad ] ];
										mergeBlock: loadBlock;
										yourself)
								selecting: #view
								main: main ] ].
			main updateCenterSideHistory: s ]
		label: 'upgrade ' , cv versionString
		on: html! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 07/21/2011 15:45'!
renderValidateConfigurationCommandOn: html main: main
	self
		renderButton: [ :s | 
			| results |
			results := MetacelloToolBox validateConfiguration: self mbConfigurationInfo configurationClass.
			results isEmpty
				ifTrue: [ self currentSession push: 'Configuration validates clean' selecting: #view ]
				ifFalse: [ self currentSession push: results selecting: #inspect ].
			main updateCenterSideHistory: s ]
		label: 'validate'
		on: html! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 6/16/2011 10:13'!
renderViewContentOn: html main: main

	self renderContentOn: html main: main
! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 7/9/2011 10:50'!
reset
	super reset.
	self mbConfigurationInfo: nil! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/23/2011 17:22'!
tODEConfigurationViewSidebarSpec
	^ {((TOTabSpec new)
		id: #configurationViewClasses;
		renderer: ((TOConfigurationSidebar new) specLabel: #view; yourself);
		receiver: self;
		label: 'configuration view classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!TOConfiguration methodsFor: 'printing' stamp: 'DataCurator 07/18/2011 15:12'!
tODEPrintString
	^ self mbConfigurationInfo tODEPrintString
! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/16/2011 11:20'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: self;
		sidebarSpec: self tODEConfigurationViewSidebarSpec;
		yourself! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 11:07'!
workingCopy

	^self mbConfigurationInfo workingCopy  ! !

TOMetacelloView subclass: #TOConfigurationList
	instanceVariableNames: 'showDetails'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOConfigurationList methodsFor: 'rendering' stamp: 'dkh 08/04/2011 17:02'!
renderCommandsOn: html main: main
	self renderSearchCommandsOn: html main: main.
	html horizontalRule.
	self renderCreateProjectCommandOn: html main: main.
	html break.
	self renderLoadArchivedVersionCommandOn: html main: main! !

!TOConfigurationList methodsFor: 'rendering' stamp: 'DataCurator 07/15/2011 10:53'!
renderFindClassCommandOn: html main: main
	| id searchText searchBlock |
	searchText := Array with: nil.	"see http://code.google.com/p/glassdb/issues/detail?id=221"
	searchBlock := [ :script | 
	| search searchResults |
	search := TOSearch new frame: self frame.
	searchResults := search classResultsFor: [ :cl | search classSatisfiesQuery: cl query: (searchText at: 1) ].
	self
		pushit: (self searchResults: searchResults labeled: 'Search for ' , (searchText at: 1) printString)
		selecting: #view
		main: main.
	main updateCenterSideHistory: script.
	script << ((html jQuery id: id) value: '') ].
	(html textInput)
		id: (id := html nextId);
		exampleText: 'class name';
		value: (searchText at: 1);
		onEnter:
				((html jQuery ajax)
						callback: [ :value | searchText at: 1 put: value ] value: (html jQuery id: id) value;
						script: searchBlock).
	html space.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | searchText at: 1 put: value ] value: (html jQuery id: id) value;
						script: searchBlock);
		with: 'Find Class'! !

!TOConfigurationList methodsFor: 'rendering-archive' stamp: 'dkh 07/24/2011 10:05'!
renderLoadArchivedVersionCommandOn: html main: main
	| descriptions repositories |
	repositories := self repositories.
	descriptions := repositories collect: [ :each | each description ].
	self
		renderCommand: [ :s :archiveRepository | 
			| configRefMap configName configRef configurationInfo |
			configRefMap := self metacelloConfigurationReferencesFrom: archiveRepository.
			configName := configRefMap keys size > 1
				ifTrue: [ self halt: 'need to handle multiple configurations' ]
				ifFalse: [ configRefMap keys anyOne ].
			configRef := (configRefMap at: configName) asSortedCollection asArray last.
			self
				deploy: [ 
					(Gofer new)
						repository: archiveRepository;
						version: configRef name;
						load ].
			configurationInfo := MBConfigurationRoot current configurationInfoFor: (Smalltalk at: configRef packageName asSymbol).
			self currentSession
				push:
					((TOArchivedConfiguration new)
						mbConfigurationInfo: configurationInfo;
						archiveRepository: archiveRepository;
						yourself)
				selecting: #view.
			main updateCenterSideHistory: s ]
		names: descriptions
		values: repositories
		label: 'load archived version'
		on: html
		main: main! !

!TOConfigurationList methodsFor: 'rendering' stamp: 'dkh 07/20/2011 15:37'!
renderProjectListOn: html main: main
	(html span)
		class: 'naviode';
		with: [ 
					MBConfigurationRoot current configurations
						do: [ :config | 
							self
								renderLink: [ :s | 
									self currentSession push: config selecting: #view.
									main updateCenterSideHistory: s ]
								with: [ 
									self showDetails
										ifTrue: [ config renderStyledLabelOn: html main: main ]
										ifFalse: [ 
											(html span)
												class: config todeCssClass;
												with: [ html text: (MetacelloToolBox baseNameOf: config name) ] ] ]
								on: html.
							html break ] ]! !

!TOConfigurationList methodsFor: 'rendering' stamp: 'dkh 7/9/2011 07:55'!
renderSearchCommandsOn: html main: main
	self renderSearchCommandOn: html main: main.
	html break.
	self renderFindClassCommandOn: html main: main! !

!TOConfigurationList methodsFor: 'rendering' stamp: 'dkh 7/8/2011 08:19'!
renderViewContentOn: html main: main
	advancedSearch ifNotNil: [ ^ self renderAdvancedSearchResultsOn: html main: main ].
	configurationSearchResults ifNotNil: [ ^ self renderSearchResultsOn: html main: main ].
	self renderProjectListOn: html main: main.
	html horizontalRule.
	html horizontalRule.
	self renderCommandsOn: html main: main! !

!TOConfigurationList methodsFor: 'accessing' stamp: 'dkh 6/21/2011 10:23'!
showDetails
	showDetails ifNil: [ showDetails := false ].
	^ showDetails! !

!TOConfigurationList methodsFor: 'accessing' stamp: 'dkh 6/21/2011 10:32'!
showDetails: aBool
	showDetails := aBool! !

TOMetacelloView subclass: #TOMetacelloSaveView
	instanceVariableNames: 'repository versionName commitComment parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOMetacelloSaveView subclass: #TOCheckpointSaveView
	instanceVariableNames: 'mbConfigurationInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOCheckpointSaveView methodsFor: 'accessing' stamp: 'DataCurator 07/18/2011 16:29'!
commitBlock
	^ [ :s :main | 
	[ 
	MetacelloToolBox
		saveModifiedPackagesAndConfigurationIn: self mbConfigurationInfo configurationClass
		description: self commitComment ]
		on: Warning
		do: [ :ex | 
			Transcript
				cr;
				show: ex description.
			ex resume ].
	self pushit: self parent selecting: #view main: main.
	main updateCenterSideHistory: s ]! !

!TOCheckpointSaveView methodsFor: 'accessing' stamp: 'DataCurator 07/18/2011 16:35'!
defaultCommitComment
	| refString |
	(refString := self mbConfigurationInfo extractPackageSignatureFrom: self workingCopy) notEmpty
		ifTrue: [ 
			| index version |
			index := refString lastIndexOf: $..
			index > 0
				ifTrue: [ 
					version := (refString copyFrom: index + 1 to: refString size) asInteger + 1.
					refString := ' (' , MetacelloPlatform current authorName , '.', version printString , ')' ] ].
	^ self mbConfigurationInfo currentVersion versionString , refString , ':'! !

!TOCheckpointSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:21'!
mbConfigurationInfo
	^mbConfigurationInfo! !

!TOCheckpointSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:21'!
mbConfigurationInfo: anMBInfo
	mbConfigurationInfo := anMBInfo! !

!TOCheckpointSaveView methodsFor: 'rendering' stamp: 'DataCurator 07/18/2011 16:36'!
renderVersionNameFieldOn: html main: main
	html strong: self versionName.
	html break! !

!TOCheckpointSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:35'!
workingCopy

	self mbConfigurationInfo ifNil: [ ^nil ].
	^self mbConfigurationInfo workingCopy  ! !

!TOMetacelloSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:38'!
commitComment
	commitComment ifNil: [ commitComment := self defaultCommitComment ].
	^ commitComment! !

!TOMetacelloSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:30'!
commitComment: aString
	commitComment := aString! !

!TOMetacelloSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:38'!
defaultCommitComment
	^'commit comment'! !

!TOMetacelloSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:30'!
parent
	^ parent! !

!TOMetacelloSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:30'!
parent: aTOMetacelloView
	parent := aTOMetacelloView! !

!TOMetacelloSaveView methodsFor: 'rendering' stamp: 'DataCurator 07/18/2011 16:30'!
renderVersionNameFieldOn: html main: main
	| vid |
	(html textInput)
		id: (vid := html nextId);
		size: self versionName size + 5;
		value: self versionName;
		onChange: (html jQuery ajax callback: [ :value | versionName := value ] value: (html jQuery id: vid) value).
	html break! !

!TOMetacelloSaveView methodsFor: 'rendering' stamp: 'DataCurator 07/18/2011 16:31'!
renderViewContentOn: html main: main
	| names id |
	self renderVersionNameFieldOn: html main: main.
	(html textArea)
		id: (id := html nextId);
		columns: ((self textAreaColumns: self commitComment) max: 80);
		rows: ((self textAreaRows: self commitComment) max: 10);
		value: self commitComment;
		onChange: (html jQuery ajax callback: [ :value | self commitComment: value ] value: (html jQuery id: id) value).
	html break.
	self
		renderButton: [ :s | self commitBlock value: s value: main ]
		label: 'commit'
		on: html.
	html space.
	self
		renderButton: [ :s | 
			self pushit: self parent selecting: #view main: main.
			main updateCenterSideHistory: s ]
		label: 'cancel'
		on: html! !

!TOMetacelloSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:30'!
repository
	^ repository! !

!TOMetacelloSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:30'!
repository: aRepo
	repository := aRepo! !

!TOMetacelloSaveView methodsFor: 'accessing' stamp: 'DataCurator 07/15/2011 11:47'!
versionName
	versionName
		ifNil: [ 
			| wc |
			(wc := self workingCopy)
				ifNil: [ versionName := self name , '-' , MCPlatformSupport authorInitials , '.1' ]
				ifNotNil: [ versionName := wc uniqueVersionName ] ].
	^ versionName! !

!TOMetacelloSaveView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 15:30'!
versionName: aString
	versionName := aString! !

TOMetacelloSaveView subclass: #TOPackageSaveView
	instanceVariableNames: 'workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPackageSaveView methodsFor: 'accessing' stamp: 'DataCurator 07/15/2011 12:19'!
commitBlock

	^[ :s :main | 
			| newVersion |
			newVersion := self workingCopy newVersionWithName: self versionName message: self commitComment.
			self repository storeVersion: newVersion.
			self pushit: self parent selecting: #view main: main.
			main updateCenterSideHistory: s ]! !

!TOPackageSaveView methodsFor: 'accessing' stamp: 'DataCurator 07/15/2011 12:15'!
workingCopy
	^ workingCopy! !

!TOPackageSaveView methodsFor: 'accessing' stamp: 'DataCurator 07/15/2011 12:15'!
workingCopy: anMCWorkingCopy
	workingCopy := anMCWorkingCopy! !

TOMetacelloView subclass: #TOMetacelloUpgradeVersionView
	instanceVariableNames: 'parent modifiedPkgDirectives mergeBlock loadBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOMetacelloUpgradeVersionView methodsFor: 'accessing' stamp: 'dkh 7/24/2011 08:47'!
loadBlock
	^ loadBlock! !

!TOMetacelloUpgradeVersionView methodsFor: 'accessing' stamp: 'dkh 7/24/2011 08:48'!
loadBlock: aBlock
	loadBlock := aBlock! !

!TOMetacelloUpgradeVersionView methodsFor: 'accessing' stamp: 'dkh 7/24/2011 08:47'!
mergeBlock
	^ mergeBlock! !

!TOMetacelloUpgradeVersionView methodsFor: 'accessing' stamp: 'dkh 7/24/2011 08:48'!
mergeBlock: aBlock
	mergeBlock := aBlock! !

!TOMetacelloUpgradeVersionView methodsFor: 'accessing' stamp: 'dkh 7/24/2011 09:00'!
modifiedPkgDirectives
	modifiedPkgDirectives ifNil: [ ^ #() ].
	^ modifiedPkgDirectives! !

!TOMetacelloUpgradeVersionView methodsFor: 'accessing' stamp: 'dkh 7/24/2011 08:47'!
modifiedPkgDirectives: aCollection
	modifiedPkgDirectives := aCollection! !

!TOMetacelloUpgradeVersionView methodsFor: 'accessing' stamp: 'dkh 7/24/2011 09:05'!
parent
	^ parent! !

!TOMetacelloUpgradeVersionView methodsFor: 'accessing' stamp: 'dkh 7/24/2011 09:05'!
parent: anObject
	parent := anObject! !

!TOMetacelloUpgradeVersionView methodsFor: 'rendering' stamp: 'dkh 7/24/2011 09:11'!
renderViewContentOn: html main: main
	html strong: 'Modified packages:'.
	html break.
	html
		unorderedList: [ 
			self modifiedPkgDirectives
				do: [ :pkgDirective | 
					html text: pkgDirective packageName.
					html break ] ].
	self
		renderButton: [ :s | 
			self loadBlock on: Warning do: [ :ex | ex resume ].
			self pushit: self parent selecting: #view main: main.
			main updateCenterSideHistory: s ]
		label: 'Load over modified packages'
		on: html.
	html break.
	self
		renderButton: [ :s | 
			modifiedPkgDirectives do: [ :pkgDirective | pkgDirective externalReference version merge ].
			self mergeBlock value.
			self pushit: self parent selecting: #view main: main.
			main updateCenterSideHistory: s ]
		label: 'Allow me to merge modified packages and then complete the load'
		on: html.
	html break.
	self
		renderButton: [ :s | 
			self pushit: self modifiedPkgDirectives selecting: #inspect main: main.
			main updateCenterSideHistory: s ]
		label: 'Cancel load and inspect list of the packages requiring a merge'
		on: html.
	html break.
	self
		renderButton: [ :s | 
			self pushit: self parent selecting: #view main: main.
			main updateCenterSideHistory: s ]
		label: 'Cancel load'
		on: html.
	html break! !

!TOMetacelloView methodsFor: 'private' stamp: 'dkh 08/04/2011 17:04'!
doCreateProject: projectName main: main
	| configurationClassName |
	configurationClassName := 'ConfigurationOf' , projectName.
	Smalltalk globals
		at: configurationClassName asSymbol
		ifPresent: [ :ex | ^ self pushit: 'Class ' , configurationClassName printString , ' already exists.' selecting: #view main: main ].
	MetacelloToolBox new createConfiguration: projectName.
	self
		pushit: (MBConfigurationRoot current configurationInfoFor: (Smalltalk at: configurationClassName asSymbol))
		selecting: #view
		main: main! !

!TOMetacelloView methodsFor: 'rendering-search' stamp: 'dkh 7/5/2011 11:12'!
doSearch: term main: main
	| map searchResults |
	map := self repositoryMapFor: self selectedRepositoryName.
	searchResults := (map keys select: [ :each | each includesSubstring: term caseSensitive: false ]) sorted.
	advancedSearch := nil.
	configurationSearchResults := searchResults collect: [ :name | (map at: name) first ].
	self
		pushit: self
		selecting: #view
		main: main! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/10/2011 10:59'!
latestLinearVersion
	| prj excluded latestVersion |
	prj := self mbConfigurationInfo project.
	excluded := prj excludeFromLatestVersion copyWithout: #development.
	^prj latestVersionMatching: '?' excludedBlessings: excluded! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/10/2011 10:39'!
mbConfigurationInfo
	self subclassResponsibility! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'DataCurator 07/18/2011 11:30'!
mbPackageInfo
	self subclassResponsibility! !

!TOMetacelloView methodsFor: 'private' stamp: 'dkh 7/5/2011 11:12'!
metacelloConfigurationReferencesFrom: aRepository
	| map |
	map := Dictionary new.
	aRepository goferReferences
		do: [ :ref | 
			(ref packageName beginsWith: 'ConfigurationOf')
				ifTrue: [ 
					| nameWithBranch |
					nameWithBranch := ref metacelloPackageNameWithBranch at: 2.
					nameWithBranch := nameWithBranch copyFrom: 'ConfigurationOf' size + 1 to: nameWithBranch size.
					(map at: nameWithBranch ifAbsent: [ map at: nameWithBranch put: OrderedCollection new ]) add: ref ] ].
	^ map! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/10/2011 10:38'!
nextBaselineVersion
	| latestVersion |
	latestVersion := self mbConfigurationInfo project latestVersion: #baseline.
	latestVersion ifNil: [ ^ '0.1-baseline' ].
	^ latestVersion versionNumber incrementMinorVersionNumber versionString! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/10/2011 11:00'!
nextVersion
	|latestVersion |
	latestVersion := self latestLinearVersion.
	latestVersion ifNil: [ ^ '0.1' ].
	^ latestVersion versionNumber incrementMinorVersionNumber versionString! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 08/04/2011 17:51'!
refresh
! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/11/2011 18:50'!
renderAddBaselineCommandUsing: baselineVersion label: label on: html main: main
	| initialText |
	initialText := self nextBaselineVersion.
	self
		renderCommand: [ :s :versionString | 
			| configurationInfo baselineVersionString |
			baselineVersionString := versionString.
			configurationInfo := self mbConfigurationInfo.
			(MetacelloToolBox configurationNamed: configurationInfo configurationClass name)
				createVersionMethod: 'baseline' , (MetacelloToolBox stripVersionStringForSelector: baselineVersionString) , ':'
					inCategory: 'baselines'
					forVersion: baselineVersionString;
				addSectionsFrom: baselineVersion versionString
					forBaseline: true
					updateProjects: false
					updatePackages: false
					versionSpecsDo: [ :attribute :versionSpec | 
						attribute == #common
							ifTrue: [ 
								"update the author, blessing, description and timeStamp"
								versionSpec
									author: MetacelloPlatform current authorName;
									blessing: #baseline;
									timestamp: MetacelloPlatform current timestamp ].
						true ];
				commitMethod.
			self refresh.
			self pushit: (configurationInfo baselineInfoFor: baselineVersionString) selecting: #view main: main ]
		initialText: initialText
		label: label
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/10/2011 13:15'!
renderAddBaselineCommandUsing: baselineVersion on: html main: main
	self
		renderAddBaselineCommandUsing: baselineVersion
		label: 'add baseline'
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/11/2011 18:50'!
renderAddDevelopmentVersionCommandImporting: importedVersion label: label on: html main: main
	| initialText |
	initialText := self nextVersion.
	self
		renderCommand: [ :s :versionString | 
			| configurationInfo toolbox developmentVersionString |
			configurationInfo := self mbConfigurationInfo.
			developmentVersionString := versionString.
			(toolbox := MetacelloToolBox configurationNamed: configurationInfo configurationClass name)
				createVersionMethod: 'version' , (MetacelloToolBox stripVersionStringForSelector: developmentVersionString) , ':'
					inCategory: 'versions'
					forVersion: developmentVersionString;
				importFrom: importedVersion versionString
					updateProjects: true
					updatePackages: true
					versionSpecsDo: [ :attribute :versionSpec | 
						attribute == #common
							ifTrue: [ 
								"update the author, blessing, description and timeStamp"
								versionSpec
									author: MetacelloPlatform current authorName;
									blessing: #development;
									timestamp: MetacelloPlatform current timestamp ].
						true ];
				commitMethod.
			toolbox
				symbolicVersionMethod: #development;
				addSymbolicSection: #common version: developmentVersionString;
				commitMethod.
			self refresh.
			self pushit: (configurationInfo versionInfoFor: developmentVersionString) selecting: #view main: main ]
		initialText: initialText
		label: label
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/10/2011 13:15'!
renderAddDevelopmentVersionCommandImporting: importedVersion on: html main: main
	self
		renderAddDevelopmentVersionCommandImporting: importedVersion
		label: 'add version'
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/11/2011 19:41'!
renderAddDevelopmentVersionCommandUsing: linearVersion label: label on: html main: main
	| initialText |
	initialText := self nextVersion.
	self
		renderCommand: [ :s :versionString | 
			| configurationInfo toolbox developmentVersionString imports |
			configurationInfo := self mbConfigurationInfo.
			developmentVersionString := versionString.
			(toolbox := MetacelloToolBox configurationNamed: configurationInfo configurationClass name)
				createVersionMethod: 'version' , (MetacelloToolBox stripVersionStringForSelector: developmentVersionString) , ':'
					inCategory: 'versions'
					forVersion: developmentVersionString;
				addSectionsFrom: linearVersion versionString
					forBaseline: false
					updateProjects: true
					updatePackages: true
					versionSpecsDo: [ :attribute :versionSpec | 
						attribute == #common
							ifTrue: [ 
								"update the author, blessing, description and timeStamp"
								versionSpec
									author: MetacelloPlatform current authorName;
									description: '';
									blessing: #development;
									timestamp: MetacelloPlatform current timestamp ].
						true ];
				commitMethod.
			toolbox
				symbolicVersionMethod: #development;
				addSymbolicSection: #common version: developmentVersionString;
				commitMethod.
			self refresh.
			self pushit: (configurationInfo versionInfoFor: developmentVersionString) selecting: #view main: main ]
		initialText: initialText
		label: label
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/10/2011 13:16'!
renderAddDevelopmentVersionCommandUsing: linearVersion on: html main: main
	self
		renderAddDevelopmentVersionCommandUsing: linearVersion
		label: 'add version'
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'DataCurator 07/13/2011 09:10'!
renderAddEmptyBaselineCommand: label On: html main: main
	| initialText |
	initialText := self nextBaselineVersion.
	self
		renderVersionCommand: [ :s :versionString | 
			| configurationInfo baselineVersionString |
			baselineVersionString := versionString ifNil: [ initialText ].
			configurationInfo := self mbConfigurationInfo.
			(MetacelloToolBox configurationNamed: configurationInfo configurationClass name)
				createVersionMethod: 'baseline' , (MetacelloToolBox stripVersionStringForSelector: baselineVersionString) , ':'
					inCategory: 'baselines'
					forVersion: baselineVersionString;
				addSection: #common
					repository: nil
					requiredProjects: #()
					packages: #()
					dependencies: #()
					groups: #()
					versionSpecsDo: [ :versionSpec | versionSpec blessing: #baseline ];
				commitMethod.
			self pushit: (configurationInfo baselineInfoFor: baselineVersionString) selecting: #view main: main ]
		exampleText: initialText
		label: label
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 7/10/2011 13:16'!
renderAddEmptyBaselineCommandOn: html main: main
	self renderAddEmptyBaselineCommand: 'add new baseline' On: html main: main! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'DataCurator 07/15/2011 12:05'!
renderAddPackageCommand: exampleText label: label on: html main: main
	| pid id selectedIndex repositories descriptions packageName |
	packageName := Array with: nil.	"see http://code.google.com/p/glassdb/issues/detail?id=221"
	selectedIndex := Array with: 1.
	repositories := self repositories.
	descriptions := repositories collect: [ :each | each description ].
	self
		renderButton: [ :s | 
			| wc pName |
			pName := (packageName at: 1) ifNil: [ exampleText ].
			PackageInfo registerPackageName: pName.
			wc := MCWorkingCopy forPackage: (MCPackage new name: pName).
			wc repositoryGroup addRepository: (repositories at: (selectedIndex at: 1) asInteger).
			main updateCenterSideHistory: s ]
		label: label
		on: html.
	html space.
	(html textInput)
		id: (pid := html nextId);
		value: exampleText;
		size: exampleText size + 5;
		onChange: (html jQuery ajax callback: [ :value | packageName at: 1 put: value ] value: (html jQuery id: pid) value).
	html space.
	(html select)
		id: (id := html nextId);
		list: descriptions;
		callback: [ :value | selectedIndex at: 1 put: value ];
		onChange: (html jQuery ajax callback: [ :value | selectedIndex at: 1 put: value ] value: (html jQuery id: id) value)! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'DataCurator 07/15/2011 12:06'!
renderAddPackageCommandOn: html main: main
	self
		renderAddPackageCommand: self actualClass category asString
		label: 'create Package'
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'DataCurator 07/15/2011 11:33'!
renderAddRepositoryCommandOn: html main: main
	| id repositoryDescription exampleText |
	repositoryDescription := Array with: nil.	"see http://code.google.com/p/glassdb/issues/detail?id=221"
	exampleText := 'http://www.squeaksource.com/' , self actualClass category.
	self
		renderButton: [ :s | 
			| repo |
			repo := MetacelloPlatform current
				createRepository: (MetacelloRepositorySpec new description: ((repositoryDescription at: 1) ifNil: [ exampleText ])).
			MCRepositoryGroup default addRepository: repo.
			main updateCenterSideHistory: s ]
		label: 'create Repository'
		on: html.
	html space.
	(html textInput)
		id: (id := html nextId);
		value: exampleText;
		size: exampleText size + 5;
		onChange:
				(html jQuery ajax callback: [ :value | repositoryDescription at: 1 put: value ] value: (html jQuery id: id) value).
	html space.
	html
		small: [ 
			html strong: 'Examples: '.
			html text: '''http://example.com/repo'', ''/pathToRepo'', etc.' ]! !

!TOMetacelloView methodsFor: 'rendering-search' stamp: 'dkh 7/5/2011 11:12'!
renderAdvancedSearchResultsOn: html main: main
	| names id |
	configurationSearchResults := nil.
	html strong: 'Advanced Search'.
	html break.
	html break.
	names := (self repositories collect: [ :each | each description ]) sorted.
	(names includes: self selectedRepositoryName)
		ifFalse: [ selectedRepositoryName := names first ].
	html text: 'Use '.
	(html select)
		id: (id := html nextId);
		list: names;
		selected: selectedRepositoryName;
		onChange: (html jQuery ajax callback: [ :value | selectedRepositoryName := value ] value: (html jQuery id: id) value).
	html text: ' to search for '.
	(html textInput)
		id: (id := html nextId);
		exampleText: 'ProjectName';
		value: searchTerm;
		script:
				(html jQuery this autocomplete
						sourceCallback: [ :term | 
							| filtered |
							filtered := (self repositoryMapFor: self selectedRepositoryName) keys.
							filtered := (term = '?'
								ifTrue: [ filtered ]
								ifFalse: [ filtered select: [ :each | each includesSubstring: term caseSensitive: false ] ]) sorted.
							filtered size > 12
								ifTrue: [ filtered := filtered first: 24 ].
							filtered ]);
		onEnter:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: searchTerm) ]);
		onChange: (html jQuery ajax callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value).
	html space.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s ]);
		with: 'Find'.
	html break.
	html
		unorderedList: [ 
			html
				small: [ 
					html
						emphasis: [ 
							html text: '('.
							html strong: 'Hint: '.
							html text: 'Type a ''?'' to list all project configurations in repository)' ] ] ]! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'dkh 7/7/2011 15:55'!
renderCommand: commandBlock exampleText: exampleText label: label on: html main: main
	| string id |
	self
		renderButton: [ :s | 
			commandBlock value: s value: string.
			main updateCenterSideHistory: s ]
		label: label
		on: html.
	html space.
	(html textInput)
		id: (id := html nextId);
		exampleText: exampleText;
		value: string;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | string := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									commandBlock value: s value: string.
									main updateCenterSideHistory: s ]);
		onChange: (html jQuery ajax callback: [ :value | string := value ] value: (html jQuery id: id) value)! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'dkh 7/11/2011 18:48'!
renderCommand: commandBlock initialText: initialText label: label on: html main: main
	| string id |
	string := initialText.
	self
		renderButton: [ :s | 
			commandBlock value: s value: string.
			main updateCenterSideHistory: s ]
		label: label
		on: html.
	html space.
	(html textInput)
		id: (id := html nextId);
		value: string;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | string := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									commandBlock value: s value: string.
									main updateCenterSideHistory: s ]);
		onChange: (html jQuery ajax callback: [ :value | string := value ] value: (html jQuery id: id) value)! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'dkh 7/7/2011 16:20'!
renderCommand: commandBlock names: names label: label on: html main: main
	self
		renderCommand: commandBlock
		names: names
		values: names
		label: label
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'DataCurator 07/15/2011 11:24'!
renderCommand: commandBlock names: names values: values label: label on: html main: main
	| id selection |
	names isEmpty
		ifTrue: [ ^ self ].
	selection := Array with: (names at: 1).
	self
		renderButton: [ :s | 
			commandBlock value: s value: (values at: (names indexOf: (selection at: 1))).
			main updateCenterSideHistory: s ]
		label: label
		on: html.
	html space.
	(html select)
		id: (id := html nextId);
		list: names;
		onChange: (html jQuery ajax callback: [ :value | selection at: 1 put: value ] value: (html jQuery id: id) value)! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'dkh 08/04/2011 17:05'!
renderCreateProjectCommandOn: html main: main
	| id projectName |
	projectName := Array with: nil.	"see http://code.google.com/p/glassdb/issues/detail?id=221"
	(html textInput)
		id: (id := html nextId);
		exampleText: 'ProjectName';
		value: (projectName at: 1);
		onEnter:
				((html jQuery ajax)
						callback: [ :value | projectName at: 1 put: value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doCreateProject: (projectName at: 1) main: main.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: projectName) ]);
		onChange: (html jQuery ajax callback: [ :value | projectName at: 1 put: value ] value: (html jQuery id: id) value).
	html space.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | projectName at: 1 put: value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doCreateProject: (projectName at: 1) main: main.
									main updateCenterSideHistory: s ]);
		with: 'Create Project'! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'dkh 7/19/2011 18:27'!
renderPackageChangesCommandOn: html main: main
	| wc repos names label |
	wc := self workingCopy ifNil: [ ^ self ].
	repos := wc repositoryGroup repositories.
	names := repos collect: [ :r | r description ].
	label := 'changes'.
	wc modified
		ifTrue: [ label := '* ' , label ].
	self
		renderCommand: [ :s :repo | 
			| patch patchLabel toPatch fullName |
			patch := wc changesRelativeToRepository: repo.
			patch
				ifNotNil: [ 
					patch isEmpty
						ifTrue: [ 
							wc modified: false.
							self currentSession push: 'No changes' selecting: #view ]
						ifFalse: [ 
							wc modified: true.
							fullName := wc ancestry ancestors isEmpty
								ifTrue: [ wc packageName ]
								ifFalse: [ wc ancestry ancestors first name ].
							patchLabel := 'Changes for ' , fullName , ' (' , patch operations size printString , ' changes)'.
							toPatch := (TOPatch new)
								object: patch;
								patchLabel: patchLabel;
								yourself.
							self currentSession push: toPatch selecting: #view ].
					main updateCenterSideHistory: s ] ]
		names: names
		values: repos
		label: label
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'dkh 07/21/2011 15:57'!
renderPackageHistoryCommandOn: html main: main
	| wc |
	wc := self workingCopy ifNil: [ ^ self ].
	wc ancestors isEmpty
		ifTrue: [ ^ self ].
	html break.
	self
		renderButton: [ :s | 
			| infos ancestry |
			ancestry := wc ancestors first.
			infos := (TOCollection new)
				label: 'History for ' , wc packageName;
				collection: ancestry withBreadthFirstAncestors;
				selectedTab: #view;
				printStringBlock: [ :item | item name , ' (' , item date asString , ', ' , item time asString , ')' ];
				itemRenderBlock: [ :item :r :m | r preformatted: item summary ];
				yourself.
			self currentSession push: infos selecting: #view.
			main updateCenterSideHistory: s ]
		label: 'history'
		on: html! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'dkh 07/20/2011 15:37'!
renderRemoveVersionCommandOn: html main: main
	| ajax imported |
	imported := Set new.
	self mbConfigurationInfo configurationClass project versions
		do: [ :version | imported addAll: version importedVersions ].
	self version blessing ~~ #development
		ifTrue: [ ^ self ].
	(imported includes: self version versionString)
		ifTrue: [ ^ self ].
	ajax := html jQuery ajax.
	ajax
		confirm:
			'Are you sure you want to remove ' , self version versionString printString , ' from '
				, (MetacelloToolBox baseNameOf: self mbConfigurationInfo configurationClass name) , '?'.
	ajax
		script: [ :s | 
			| cm |
			self mbConfigurationInfo configurationClass project symbolicVersionSymbols
				do: [ :symbolicVersion | 
					(MetacelloToolBox configurationNamed: self mbConfigurationInfo configurationClass name asString)
						modifySymbolicVersionMethodFor: symbolicVersion
							symbolicVersionSpecsDo: [ :symbolicVersionSpec | 
									symbolicVersionSpec versionString = self version versionString
										ifTrue: [ symbolicVersionSpec versionString: #notDefined ].
									true ];
						commitMethod ].
			cm := MetacelloToolBox compiledMethodForVersion: self version.
			cm methodClass removeSelector: cm selector.
			self currentSession push: self mbConfigurationInfo selecting: #view.
			main updateCenterSideHistory: s ].
	(html submitButton)
		onClick: ajax;
		with: 'remove'! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'dkh 07/24/2011 10:02'!
renderRevertCommandOn: html main: main
	| wc selectedName ancestors ancestorNames id ajax label |
	(wc := self workingCopy) ifNil: [ ^ self ].
	ancestors := wc ancestry breadthFirstAncestors.
	ancestors isEmpty
		ifTrue: [ ^ self ].
	label := 'revert'.
	wc modified
		ifTrue: [ label := '* ' , label ].
	html break.
	ancestorNames := ancestors collect: [ :ea | ea name ].
	selectedName := Array with: ancestorNames first.	"see http://code.google.com/p/glassdb/issues/detail?id=221"
	ajax := html jQuery ajax.
	wc modified
		ifTrue: [ 
			ajax
				confirm:
					'You are about to load a new version of ' , (wc packageName copyUpToLast: #-) printString
						, ' that has unsaved changes in the image. If you continue, you will lose these changes?' ].
	ajax
		script: [ :s | 
			| info |
			[ 
			info := ancestors at: (ancestorNames indexOf: (selectedName at: 1)).
			self
				deploy: [ (wc repositoryGroup versionWithInfo: info ifNone: [ ^ s alert: 'No repository found for ' , info name ]) load ] ]
				on: Warning
				do: [ :ex | ex resume: true ].
			s alert: 'Reverted: ' , info name.
			main updateCenterSideHistory: s ].
	(html submitButton)
		onClick: ajax;
		with: label.
	html space.
	(html select)
		id: (id := html nextId);
		list: ancestorNames;
		selected: (selectedName at: 1);
		onChange: (html jQuery ajax callback: [ :value | selectedName at: 1 put: value ] value: (html jQuery id: id) value)! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'DataCurator 07/15/2011 12:16'!
renderSavePackageCommandOn: html main: main
	| wc repos names label |
	wc := self workingCopy ifNil: [ ^ self ].
	repos := wc repositoryGroup repositories reversed.
	names := repos collect: [ :r | r description ].
	label := 'save'.
	wc modified
		ifTrue: [ label := '* ' , label ].
	self
		renderCommand: [ :s :repo | 
			self
				pushit:
					((TOPackageSaveView new)
						workingCopy: self workingCopy;
						repository: repo;
						parent: self;
						yourself)
				selecting: #view
				main: main.
			main updateCenterSideHistory: s ]
		names: names
		values: repos
		label: label
		on: html
		main: main! !

!TOMetacelloView methodsFor: 'rendering-search' stamp: 'dkh 7/5/2011 11:22'!
renderSearchCommandOn: html main: main
	| id |
	(html textInput)
		id: (id := html nextId);
		exampleText: 'ProjectName';
		value: searchTerm;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: searchTerm) ]);
		onChange: (html jQuery ajax callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value).
	html space.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s ]);
		with: 'Find Project'.
	html space.
	self
		renderLink: [ :s | 
			advancedSearch := true.
			self pushit: self selecting: #view main: main.
			main updateCenterSideHistory: s ]
		with: [ html text: 'advanced search' ]
		on: html.
	html space.
	html
		small: [ 
			html
				emphasis: [ 
					html text: '('.
					html strong: 'Hint:'.
					html text: ' use to find and load a project configuration).' ] ]! !

!TOMetacelloView methodsFor: 'rendering-search' stamp: 'dkh 07/21/2011 16:39'!
renderSearchResultsOn: html main: main
	self renderSearchCommandOn: html main: main.
	html break.
	html break.
	configurationSearchResults
		do: [ :resolvedReference | 
			self
				renderLink: [ :s | 
					| loader |
					loader := MCVersionLoader new.
					loader addVersion: resolvedReference version.
					loader load.
					self
						pushit: (MBConfigurationRoot current configurationInfoFor: (Smalltalk at: resolvedReference packageName asSymbol))
						selecting: #view
						main: main.
					self resetSearch.
					main updateCenterSideHistory: s ]
				with: [ html text: 'load' ]
				on: html.
			html space.
			html text: resolvedReference name.
			html break ].
	configurationSearchResults size > 20
		ifTrue: [ 
			html break.
			self renderSearchCommandOn: html main: main ]! !

!TOMetacelloView methodsFor: 'rendering-commands' stamp: 'dkh 07/24/2011 10:02'!
renderUnloadPackageCommandsOn: html main: main
	self
		renderButton: [ :s | 
			self reset.
			self deploy: [ self workingCopy unload ].
			self currentSession home.
			main updateCenterSideHistory: s ]
		label: 'unload'
		on: html! !

!TOMetacelloView methodsFor: 'rendering-version-commands' stamp: 'DataCurator 07/13/2011 09:11'!
renderVersionCommand: commandBlock exampleText: exampleText label: label on: html main: main
	| versionString id |
	versionString := exampleText.
	self
		renderButton: [ :s | commandBlock value: s value: versionString.
			main updateCenterSideHistory: s ]
		label: label
		on: html.
	html space.
	(html textInput)
		id: (id := html nextId);
		value: versionString;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | versionString := value ] value: (html jQuery id: id) value;
						script: [ :s | commandBlock value: s value: versionString.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: versionString) ]);
		onChange: (html jQuery ajax callback: [ :value | versionString := value ] value: (html jQuery id: id) value)! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 7/7/2011 16:16'!
repositories
	^ (MCRepositoryGroup default repositories reject: [ :repo | repo = MCCacheRepository default ])
		sorted: [ :a :b | a description <= b description ]! !

!TOMetacelloView methodsFor: 'private' stamp: 'dkh 7/5/2011 11:12'!
repositoryMapFor: selectedRepositoryDescription
	repositoryMap ifNil: [ repositoryMap := Dictionary new ].
	^ repositoryMap
		at: selectedRepositoryDescription
		ifAbsent: [ 
			repositoryMap
				at: selectedRepositoryDescription
				put:
					(self
						metacelloConfigurationReferencesFrom:
							(self repositories detect: [ :repo | repo description = selectedRepositoryDescription ])) ]! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 7/9/2011 10:49'!
reset! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 7/5/2011 11:12'!
resetSearch
	selectedRepositoryName := repositoryMap := configurationSearchResults := advancedSearch := nil! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 7/5/2011 11:12'!
selectedRepositoryName
	selectedRepositoryName ifNil: [ selectedRepositoryName := 'http://www.squeaksource.com/MetacelloRepository' ].
	^ selectedRepositoryName! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 7/10/2011 09:42'!
workingCopy

	self subclassResponsibility! !

TOMetacelloView subclass: #TOWorkingCopy
	instanceVariableNames: 'workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOWorkingCopy subclass: #TOPackage
	instanceVariableNames: 'mbPackageInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPackage methodsFor: 'accessing' stamp: 'dkh 7/9/2011 10:23'!
mbPackageInfo
	mbPackageInfo
		ifNil: [ 
			| wc |
			MCWorkingCopy registry
				do: [ :mgr | 
					(mgr packageInfo includesClass: self actualClass)
						ifTrue: [ wc := mgr ] ].
			wc ifNil: [ ^ nil ].
			mbPackageInfo := MBPackageInfo named: wc packageName.
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = wc packageName
								ifTrue: [ 
									mbPackageInfo := pkg.
									^ config ] ] ] ].
	^ mbPackageInfo! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/13/2011 08:18'!
mbPackageInfo: anObject
	mbPackageInfo := anObject! !

!TOPackage methodsFor: 'rendering-commands' stamp: 'dkh 7/10/2011 10:07'!
renderCommandsOn: html main: main
	self renderPackageChangesCommandOn: html main: main.
	self renderPackageHistoryCommandOn: html main: main.
	self renderRevertCommandOn: html main: main.
	self workingCopy
		ifNotNil: [ 
			html break.
			self renderSavePackageCommandOn: html main: main.
			html break.
			self renderUnloadPackageCommandsOn: html main: main ]! !

!TOPackage methodsFor: 'rendering' stamp: 'DataCurator 07/15/2011 12:00'!
renderContentOn: html main: main
	self mbPackageInfo
		ifNil: [ 
			html text: 'No package defined for this class.'.
			html
				break;
				break.
			self renderAddPackageCommandOn: html main: main.
			html break.
			self renderAddRepositoryCommandOn: html main: main.
			^ self ].
	html strong: self mbPackageInfo printString.
	html
		break;
		break.
	self renderCommandsOn: html main: main! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 7/8/2011 08:11'!
renderFrameTitleOn: html main: main
	| cl |
	self mbPackageInfo ifNil: [ ^ super renderFrameTitleOn: html main: main ].
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	(html span)
		class: 'naviode';
		with: [ 
					self mbPackageInfo renderStyledLabelOn: html main: main.
					html space.
					html small: '(' , cl name , ')' ]! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/16/2011 10:12'!
renderViewContentOn: html main: main

	self renderContentOn: html main: main
! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 7/9/2011 10:57'!
reset
	super reset.
	self mbPackageInfo: nil! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/25/2011 04:06'!
tODEPackageViewSidebarSpec
	^ {((TOTabSpec new)
		id: #packageViewClasses;
		renderer: ((TOPackageSidebar new) specLabel: #view; yourself);
		receiver: self;
		label: 'package view classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}
! !

!TOPackage methodsFor: 'printing' stamp: 'DataCurator 07/18/2011 15:12'!
tODEPrintString
	^ self mbPackageInfo tODEPrintString! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/16/2011 11:16'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		sidebarSpec: self tODEPackageViewSidebarSpec;
		yourself! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:05'!
workingCopy

	self mbPackageInfo ifNil: [ ^nil ].
	^self mbPackageInfo workingCopy  ! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:06'!
classList
	
	self workingCopy ifNil: [ ^#() ].
	^ self workingCopy packageInfo classes! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:07'!
extensionClassList
	| classes wc |
	classes := Dictionary new.
	(wc := self workingCopy) ifNil: [ ^ classes ].
	wc packageInfo extensionClasses
		do: [ :cl | 
			| cats fullCats |
			cats := wc packageInfo extensionCategoriesForClass: cl.
			fullCats := OrderedCollection new.
			cats
				do: [ :cat | 
					(cl organization listAtCategoryNamed: cat) notEmpty
						ifTrue: [ fullCats add: cat ] ].
			fullCats notEmpty
				ifTrue: [ classes at: cl put: fullCats ] ].
	^ classes! !

!TOWorkingCopy methodsFor: 'rendering' stamp: 'dkh 6/16/2011 03:50'!
renderViewContentOn: html main: main

	html text: 'work in progress ... do I really need this view ... I want to convert to MBPackageInfo or just use regular inspector ... being able to get MBPackageInfo and going from there is probably a good thing'. ! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:03'!
workingCopy
	^workingCopy! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:04'!
workingCopy: aMCWorkingCopy
	workingCopy := aMCWorkingCopy! !

TOView subclass: #TOPatch
	instanceVariableNames: 'patchLabel selectedOperation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPatch methodsFor: 'accessing' stamp: 'DataCurator 07/18/2011 10:23'!
patchLabel
	^ patchLabel! !

!TOPatch methodsFor: 'accessing' stamp: 'DataCurator 07/18/2011 10:23'!
patchLabel: aString
	patchLabel := aString! !

!TOPatch methodsFor: 'rendering' stamp: 'dkh 6/16/2011 03:49'!
renderViewContentOn: html main: main

	self selectedOperation ifNil: [html text: 'No operation selected'. ^self].
	self selectedOperation renderContentOn: html view: self main: main  ! !

!TOPatch methodsFor: 'rendering' stamp: 'DataCurator 07/18/2011 10:17'!
renderViewSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer mcPatch: self object.
	aTOTabSpec renderer renderContentOn: html main: main! !

!TOPatch methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:38'!
selectedOperation
	^ selectedOperation! !

!TOPatch methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:38'!
selectedOperation: anObject
	selectedOperation := anObject! !

!TOPatch methodsFor: 'accessing' stamp: 'dkh 07/20/2011 15:52'!
tODETitle
	self patchLabel ifNil: [ ^ super tODETitle ].
	^ self patchLabel! !

!TOPatch methodsFor: 'accessing' stamp: 'DataCurator 07/18/2011 10:16'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewPackageClasses;
		rendererClass: TOPatchList;
		receiver: self;
		label: 'changes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderViewSidebarOn:spec:tOdeMain:)}! !

!TOPatch methodsFor: 'accessing' stamp: 'DataCurator 07/18/2011 11:23'!
tODEViewTabSpec
	<tODECenterTabSpec>
	^ (super tODEViewTabSpec)
		renderer: self;
		sidebarSpec: self tODEViewSidebarSpec;
		yourself! !

TOView subclass: #TOPatchList
	instanceVariableNames: 'mcPatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPatchList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:24'!
mcPatch
	^ mcPatch! !

!TOPatchList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:24'!
mcPatch: anObject
	mcPatch := anObject! !

!TOPatchList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:34'!
patchView

	^(self frame rendererForCenterTab: #view)! !

!TOPatchList methodsFor: 'rendering' stamp: 'dkh 7/7/2011 17:11'!
renderContentOn: html main: main
	(html span)
		class: 'naviode';
		with: [ 
					(mcPatch operations sorted: [ :a :b | a summary <= b summary ])
						do: [ :operation | 
							| spanClass |
							spanClass := operation isAddition
								ifTrue: [ 'insert' ]
								ifFalse: [ 
									operation isRemoval
										ifTrue: [ 'remove' ]
										ifFalse: [ 'change' ] ].
							self
								renderLink: [ :s | 
									self patchView selectedOperation: operation.
									main updateCenterSideHistory: s ]
								with: [ 
									(html span)
										class: spanClass;
										with: [ 
													self patchView selectedOperation == operation
														ifTrue: [ html strong: operation summary ]
														ifFalse: [ html text: operation summary ] ] ]
								on: html.
							html break ] ]! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 21:02'!
renderMetacelloSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/3/2011 17:06'!
renderMetacelloTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/23/2011 17:22'!
tODEConfigurationSidebarSpec
	^ {((TOTabSpec new)
		id: #configurationClasses;
		rendererClass: TOConfigurationSidebar;
		receiver: self;
		label: 'configuration classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 11:14'!
tODEConfigurationTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #configuration;
		rendererClass: TOConfiguration;
		receiver: self;
		label: 'configuration';
		order: 10;
		group: 'monticello';
		sidebarSpec: self tODEConfigurationSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 04:06'!
tODEPackageSidebarSpec
	^ {((TOTabSpec new)
		id: #packageClasses;
		rendererClass: TOPackageSidebar;
		receiver: self;
		label: 'package classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 11:20'!
tODEPackageTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #package;
		rendererClass: TOPackage;
		receiver: self;
		label: 'package';
		order: 20;
		group: 'monticello';
		sidebarSpec: self tODEPackageSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 04:35'!
tODEVersionSidebarSpec
	^ {((TOTabSpec new)
		id: #versionSpec;
		rendererClass: TOVersionSidebar;
		receiver: self;
		label: 'version spec';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 08/09/2011 11:27'!
tODEVersionTabSpec
	"<tODECenterTabSpec>"

	^ (TOTabSpec new)
		id: #version;
		rendererClass: TOVersion;
		receiver: self;
		label: 'version';
		order: 15;
		group: 'monticello';
		sidebarSpec: self tODEVersionSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !
